-- Global Variables

TrinityDockFrames = 15;
TrinityMaxDockShapes = 5;
TrinityButtonSpaceH = 3;
TrinityButtonSpaceV = 3;
TrinityKeyBindButton = 0;
TrinityKeyBindSpell = nil;
TrinityClassShowStates = nil;
TrinityButtonStyle = 1;

TrinityFirstRun = true;
TrinityDockBarsHide = false;
TrinityButtonsHide = false;
TrinityDockingUpdated = false;
TrinityBindingsUpdated = false;
TrinityPlayerEnteredWorld = false;
TrinityCombatLockdown = false;
TrinityDockLockdown = false;
TrinityButtonLock = false;
TrinityProwlBarActive = false;

TrinitySavedVersion = "unknown"
TrinityCurrentVersion = "20000.16"

TrinitySpellBindings = {};
TrinityButtonsSavedState = {};
TrinityButtonsSavedState2 = {};
TrinityForms = {}
TrinityButtonsButtonLoc = { 12.63545630201, -121.64504791763 };
TrinityMiscBars = {
	["menu"] = 0,
	["bags"] = 0,
	["pet"] = 0,
	["form"] = 0,
	["cast"] = 0,
}

TrinityDebug = {}

-- Main on load funtion, creates frames and initializes them
function TrinityButtons_OnLoad()
 	
 	MainMenuBar:Hide();

	local stanceFrame = CreateFrame("Frame", "TrinityStanceButtons", UIParent, "SecureStateDriverTemplate");
		stanceFrame:SetAttribute("statemap-stance", "$input");						
		stanceFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");	
		stanceFrame:SetAttribute("unit2", "player");
		stanceFrame:SetAttribute("alt-unit1", "player");
		stanceFrame:SetAttribute("ctrl-unit1", "player");
		
	local pagedFrame = CreateFrame("Frame", "TrinityPagedButtons", UIParent, "SecureStateDriverTemplate");		
		pagedFrame:SetAttribute("statemap-actionbar", "$input");
		pagedFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");	
		pagedFrame:SetAttribute("unit2", "player");
		pagedFrame:SetAttribute("alt-unit1", "player");
		pagedFrame:SetAttribute("ctrl-unit1", "player");
		
	local normalFrame = CreateFrame("Frame", "TrinityNormalButtons", UIParent, "SecureStateDriverTemplate");
		normalFrame:SetAttribute("statemap", "0:=");
		normalFrame:SetAttribute("statebindings","0:zero;1:one;2:two;3:three;4:four;5:five;6:six;7:seven;8:eight;9:nine");	
		normalFrame:SetAttribute("unit2", "player");
		normalFrame:SetAttribute("alt-unit1", "player");
		normalFrame:SetAttribute("ctrl-unit1", "player");
	
	local tempDockFrame = CreateFrame("Frame", "TrinityTempDockFrame", UIParent, "SecureStateDriverTemplate");
		tempDockFrame:SetAttribute("state", "99");
		TrinityTempDockFrame.buttonIndex = {}
		for i=1,155 do
			TrinityTempDockFrame.buttonIndex[i] = 0;
		end
		TrinityTempDockFrame.buttonCount = 0;
		
	local dummyButton = CreateFrame("CheckButton", "TrinityActionButton0", TrinityStanceButtons, "SecureActionButtonTemplate");
		normalFrame:SetAttribute("addchild", dummyButton);
		dummyButton:CreateFontString("$parentHotKey", "ARTWORK", "NumberFontNormalSmall");
		dummyButton.hotkey = nil;
		dummyButton.dock = -1;
		dummyButton:SetID(0);
		dummyButton:Hide();
		
	if (UnitClass("player") == TRINITY_DRUID) then
		TrinityClassShowStates = "0,2,4,7,8,9";
	elseif (UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then
		TrinityClassShowStates = "0,2,3,4,3,6,7,8,9";
	elseif (UnitClass("player") == TRINITY_WARRIOR) then
		TrinityClassShowStates = "0,4,5,6,7,8,9";
	else
		TrinityClassShowStates = "0,1,2,3,4,5,6,7,8,9";
	end	
	
	TrinityFirstRun = true;
end

function TrinitySpellBinder_OnLoad()
	local posCount = 5
	local negCount = 0;
	for i=1,12 do
		local bindFrame = CreateFrame("Button", "TrinitySpellBinderButton"..i, getglobal("SpellButton"..i), "TrinitySpellBinderTemplate");				
		if (mod(i,2) == 0) then
			bindFrame:SetID(i+posCount);
			posCount = posCount - 1;			
		else
			bindFrame:SetID(i+negCount);
			 negCount = negCount - 1;			
		end		
		bindFrame:SetPoint("TOPLEFT", getglobal("SpellButton"..i), "TOPLEFT", 0 ,0);
		bindFrame:SetPoint("BOTTOMRIGHT", getglobal("SpellButton"..i), "BOTTOMRIGHT", 0 ,0);
		bindFrame:SetFrameLevel(getglobal("SpellButton"..i):GetFrameLevel()+1);		
		
		getglobal("SpellButton"..i):CreateFontString("$parentHotKey", "ARTWORK", "NumberFontNormalSmall");		
		getglobal("SpellButton"..i.."HotKey"):SetPoint("TOPRIGHT", -1, -5);		
	end		
	for i=1,10 do
		local bindFrame = CreateFrame("Button", "TrinitySpellBinderButton"..i+12, getglobal("ShapeshiftButton"..i), "TrinitySpellBinderTemplate");				
		bindFrame:SetID(i+12);
		bindFrame:SetPoint("TOPLEFT", getglobal("ShapeshiftButton"..i), "TOPLEFT", 0 ,0);
		bindFrame:SetPoint("BOTTOMRIGHT", getglobal("ShapeshiftButton"..i), "BOTTOMRIGHT", 0 ,0);
		bindFrame:SetFrameLevel(getglobal("ShapeshiftButton"..i):GetFrameLevel()+1);	
		getglobal("ShapeshiftButton"..i.."HotKey"):SetPoint("TOPRIGHT", 0, -3);		
		getglobal("ShapeshiftButton"..i.."HotKey"):SetTextColor(1,1,1)
	end			
end

function TrinitySpellBookFrame_OnEvent()
	if ( event == "SPELLS_CHANGED" or "UPDATE_BINDINGS") then
		if ( SpellBookFrame:IsVisible() ) then					
			SpellBookFrame_Update();
			SpellBook_UpdatePageArrows();
			for i=1,12 do
				getglobal("SpellButton"..i.."HotKey"):SetText();								
				local frameid = getglobal("TrinitySpellBinderButton"..i):GetID()
				local spellid = SpellBook_GetSpellID(frameid);
				local spellName, subSpellName = GetSpellName(spellid, SpellBookFrame.bookType);
				if (subSpellName) then
					spellName = spellName.."("..subSpellName..")".."-HotKey";
				else
					spellName = spellName.."()".."-HotKey";
				end
				for k,v in pairs(TrinitySpellBindings) do
					if (k == spellName) then
						getglobal("SpellButton"..i.."HotKey"):SetText(v);								
					end
				end
			end
		end
	elseif ( event == "LEARNED_SPELL_IN_TAB" ) then
		local flashFrame = getglobal("SpellBookSkillLineTab"..arg1.."Flash");
		if ( SpellBookFrame.bookType == BOOKTYPE_PET ) then
			return;
		else
			if ( flashFrame ) then
				flashFrame:Show();
				SpellBookFrame.flashTabs = 1;
			end
		end
	end
end

function TrinityCreateDockFrames()

	for i=1,TrinityDockFrames do
		local dockFrame = CreateFrame("Frame", "TrinityDockFrame"..i, UIParent, "TrinityDockFrameTemplate");
		dockFrame:SetID(i);		
		TrinityButtonDockDefaults(i, dockFrame);		
		getglobal(dockFrame:GetName().."Close"):Hide();
	end
end	

function TrinityCreateButtons()

	for i=1,120 do
		local actionButton = CreateFrame("CheckButton", "TrinityActionButton"..i, TrinityNormalButtons, "TrinityActionButtonTemplate");
		actionButton:SetAttribute("useparent-unit", true);				
		actionButton:SetAttribute("type", "action");		
		actionButton:SetID(i);
		getglobal("TrinityActionButton"..i.."BindFrame"):SetID(i);
		actionButton:SetAttribute("action1", i);				
		actionButton:SetAttribute("action2", i);
		actionButton:SetAttribute("alt-action1", i);				
		actionButton:SetAttribute("ctrl-action1", i);		
		actionButton.anchor = 99;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton.laststate = "";				
	end
	
	for i=121,155 do
		local actionButton = CreateFrame("Frame", "TrinityActionButton"..i, TrinityNormalButtons);						
		actionButton:CreateFontString("$parentHotKey", "ARTWORK", "NumberFontNormalSmallGray");
		actionButton:SetID(i);
		actionButton:SetWidth(36);
		actionButton:SetHeight(40);
		actionButton.anchor = 99;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton.laststate = "";				
	end
	
	Trinity_ReassignDefaultUIElements()
end

function TrinityCreateProwlCheck(i, dockFrame)

	local prowlCheck = CreateFrame("CheckButton", "TrinityProwlOption"..i, dockFrame, "TrinityCheckButtonTemplate");
		prowlCheck:SetPoint("BOTTOMRIGHT", dockFrame, "BOTTOMRIGHT",  -18, 18);		
		prowlCheck:SetScript("OnEvent", function() this:SetChecked(dockFrame.config["prowl"]); TrinitySetProwl(this); end);
		prowlCheck:SetScript("OnClick", function() TrinitySetProwl(this); end);
		prowlCheck:SetScript("OnEnter", function() GameTooltip_SetDefaultAnchor(GameTooltip, this); GameTooltip:SetText("Check to enable prowl bar", 1.0, 1.0, 1.0); GameTooltip:Show(); end);
		prowlCheck:SetScript("OnLeave", function() GameTooltip:Hide(); end);
		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			prowlCheck:SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));
		else
			prowlCheck:SetAttribute("showstates", "10-99");
		end
		TrinityStanceButtons:SetAttribute("addchild", prowlCheck);	
end

function TrinitySetProwl(frame)

	for i=1,TrinityDockFrames do		
		if (getglobal("TrinityDockFrame"..i).config["header"] == "TrinityStanceButtons") then
			getglobal("TrinityDockFrame"..i).config["prowl"] = frame:GetChecked();
			if (not getglobal("TrinityProwlOption"..i)) then
				TrinityCreateProwlCheck(i, getglobal("TrinityDockFrame"..i));
				TrinityRefreshHeaders();
			end
			getglobal("TrinityProwlOption"..i):SetChecked(getglobal("TrinityDockFrame"..i).config["prowl"]);
		end
	end
	if (frame:GetChecked()) then
		TrinityStanceButtons:SetAttribute("statemap-stealth-0", "0:=;5:=;6:3");		
		TrinityStanceButtons:SetAttribute("statemap-stealth-1", "0:=;5:=;3:6");				
		TrinityProwlBarActive = true;
	else
		TrinityStanceButtons:SetAttribute("statemap-stealth-0", "0:=;5:=;3:=");		
		TrinityStanceButtons:SetAttribute("statemap-stealth-1", "0:=;5:=;3:=");
		TrinityProwlBarActive = false;
	end
	TrinitySaveButtonState();
end


-- Function to handle default UI elements that we still want to use.
function Trinity_ReassignDefaultUIElements()

	local defaultElement = {}
	
	TrinityBagDoodads:SetFrameStrata("LOW");
	
 	defaultElement[121] = TrinityBagDoodads:GetName(); 	
 	defaultElement[123] = CharacterBag2Slot:GetName();	
 	defaultElement[122] = CharacterBag3Slot:GetName();
 	defaultElement[124] = CharacterBag1Slot:GetName();
 	defaultElement[125] = CharacterBag0Slot:GetName();
 	defaultElement[126] = MainMenuBarBackpackButton:GetName();	
  	
  	defaultElement[127] = CharacterMicroButton:GetName();   	
  	defaultElement[128] = SpellbookMicroButton:GetName();
  	defaultElement[129] = TalentMicroButton:GetName();
  	defaultElement[130] = QuestLogMicroButton:GetName();
  	defaultElement[131] = SocialsMicroButton:GetName();
  	defaultElement[132] = LFGMicroButton:GetName();
  	defaultElement[133] = MainMenuMicroButton:GetName();
  	defaultElement[134] = HelpMicroButton:GetName();  	
  	
	for i=1,10 do
		defaultElement[i+134] = getglobal("PetActionButton"..i):GetName();
 	end 	 	
	for i=1,10 do
		defaultElement[i+144] = getglobal("ShapeshiftButton"..i):GetName();		
	end	
	
	defaultElement[155] = TrinityCastingBar:GetName();

	for i=121,155 do
		getglobal(defaultElement[i]):ClearAllPoints();
		getglobal(defaultElement[i]):SetParent(getglobal("TrinityActionButton"..i));				
		if (i>126 and i<135) then
			getglobal("TrinityActionButton"..i):SetWidth(getglobal(defaultElement[i]):GetWidth()*0.8);			
			getglobal("TrinityActionButton"..i):SetHeight(getglobal(defaultElement[i]):GetHeight()/2);
			getglobal(defaultElement[i]):SetPoint("BOTTOM", getglobal("TrinityActionButton"..i), "BOTTOM");
		else
			getglobal("TrinityActionButton"..i):SetWidth(getglobal(defaultElement[i]):GetWidth());
			getglobal("TrinityActionButton"..i):SetHeight(getglobal(defaultElement[i]):GetHeight());
			getglobal(defaultElement[i]):SetPoint("CENTER", getglobal("TrinityActionButton"..i), "CENTER");
		end		
		getglobal(defaultElement[i]):Show();		
	end
	
	TrinityCastingBar:SetPoint("TOPLEFT");
	TrinityCastingBar:SetPoint("BOTTOMRIGHT");
	
	TrinityLatencyBarFrame:SetParent("TrinityBagDoodads");
	TrinityLatencyBarFrame:SetPoint("CENTER", "TrinityBagDoodads", "CENTER", -9, 0);	
 	
 	KeyRingButton:ClearAllPoints();
 	KeyRingButton:SetParent("TrinityBagDoodads");
 	KeyRingButton:SetPoint("CENTER", "TrinityBagDoodads", "LEFT", 27, 0); 	 	
 	KeyRingButton:SetHeight(34)
 	KeyRingButton:Show();	
end

function TrinityButtonDockDefaults(i, dockFrame)

	dockFrame.anchors = {};
	dockFrame.lastDocked = {};
	dockFrame.buttonCount = {};
	dockFrame.placed = {};
	dockFrame.buttonList = {};
	for i=0,9 do
		dockFrame.anchors[i] = 0;
		dockFrame.lastDocked[i] = 0;
		dockFrame.buttonCount[i] = 0;
		dockFrame.placed[i] = 0;
		dockFrame.buttonList[i] = "";			
	end
	dockFrame.config = {
		["header"] = "";
		["scale"] = 1;
		["alpha"] = 1;
		["shape"] = 0;
		["hide"] = 0;
		["columns"] = 6;
		["ghost"] = nil;	
		["prowl"] = nil;
		["vis"] = 1;		
		["showgrid"] = nil;
	}	
	dockFrame.centerx = UIParent:GetWidth()/2;
	dockFrame.centery = 30*dockFrame:GetID();	
	dockFrame.elapsed = 3;
	dockFrame.update = false;	
end

function TrinityButtonDefaults(i, actionButton, stanceFrame, pagedFrame, normalFrame)

	if (i<13) then		

		if (UnitClass("player") ~= TRINITY_WARRIOR) then
		
			actionButton.dock = 1;			
			actionButton.hotkey = tostring(i);
			actionButton.hotkeytext = tostring(i);	
			if (i==10) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==11) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==12) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			if (UnitClass("player") == TRINITY_DRUID  or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then
				actionButton:SetAttribute("showstates", TrinityClassShowStates);				
				actionButton.laststate = actionButton:GetAttribute("showstates");
				stanceFrame:SetAttribute("addchild", actionButton);				
				getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
				if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
					getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;					
					actionButton.anchor = 0;
				end
				getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;
			
			else
				actionButton:SetAttribute("showstates", "1");
				actionButton.laststate = actionButton:GetAttribute("showstates");
				pagedFrame:SetAttribute("addchild", actionButton);
				getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] + 1;
				if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[1] == 0) then
					getglobal("TrinityDockFrame"..actionButton.dock).anchors[1] = i;					
					actionButton.anchor = 1;
				end
				getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[1] = i;
			end			
			
		else
		
			actionButton.dock = 7;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");				
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
				getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;					
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					
		end
		
	elseif (i>12 and i<25) then
	
		actionButton.dock = 2;		
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
	
		if (UnitClass("player") == TRINITY_DRUID or UnitClass("player") == TRINITY_WARRIOR or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then			
			actionButton:SetAttribute("showstates", "1");		
			actionButton.laststate = actionButton:GetAttribute("showstates");
			pagedFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[1] == 0) then
				getglobal("TrinityDockFrame"..actionButton.dock).anchors[1] = i;				
				actionButton.anchor = 1;
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[1] = i;					
		else
			actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
				getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;								
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					
		end
		
	elseif (i>24 and i<37) then
		
		actionButton.dock = 3;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end			
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					

	elseif (i>36 and i<49) then
		
		actionButton.dock = 4;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					
		
	elseif (i>48 and i<61) then
		
		actionButton.dock = 5;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end			
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					
		
	elseif (i>60 and i<73) then
		
		actionButton.dock = 6;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";		
		actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end			
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					
		
	elseif (i>72 and i<85) then
	
		if (UnitClass("player") == TRINITY_DRUID) then
		
			actionButton.dock = 1;								
			actionButton.hotkey = tostring(i-72);
			actionButton.hotkeytext = tostring(i-72);	
			if (i==82) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==83) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==84) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[3] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[3] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[3] == 0) then
				actionButton.anchor = 3;
				TrinityDockFrame1.anchors[3] = i;						
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[3] = i;			
			
		elseif (UnitClass("player") == TRINITY_WARRIOR or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then
		
			actionButton.dock = 1;								
			actionButton.hotkey = tostring(i-72);
			actionButton.hotkeytext = tostring(i-72);	
			if (i==82) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==83) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==84) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", "1");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[1] == 0) then
				actionButton.anchor = 1;
				TrinityDockFrame1.anchors[1] = i;
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[1] = i;						
		else
			actionButton.dock = 7;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
				getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;					
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;							
		end
		
	elseif (i>84 and i<97) then
	
		if (UnitClass("player") == TRINITY_WARRIOR) then
		
			actionButton.dock = 1;				
			actionButton.hotkey = tostring(i-84);
			actionButton.hotkeytext = tostring(i-84);	
			if (i==94) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==95) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==96) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", "2");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[2] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[2] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[2] == 0) then
				actionButton.anchor = 2;
				TrinityDockFrame1.anchors[2] = i;
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[2] = i;							
		else
			actionButton.dock = 8;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
				getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;					
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;							
		end
		
	elseif (i>96 and i<109) then
	
		if (UnitClass("player") == TRINITY_DRUID) then
		
			actionButton.dock = 1;							
			actionButton.hotkey = tostring(i-96);
			actionButton.hotkeytext = tostring(i-96);	
			if (i==106) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==107) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==108) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", "1");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[1] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[1] == 0) then
				actionButton.anchor = 1;
				TrinityDockFrame1.anchors[1] = i;
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[1] = i;			
			
		elseif (UnitClass("player") == TRINITY_WARRIOR) then
		
			actionButton.dock = 1;							
			actionButton.hotkey = tostring(i-96);
			actionButton.hotkeytext = tostring(i-96);	
			if (i==106) then
				actionButton.hotkey = "0"; actionButton.hotkeytext = "0";
			elseif (i==107) then
				actionButton.hotkey = "-"; actionButton.hotkeytext = "-";
			elseif (i==108) then
				actionButton.hotkey = "="; actionButton.hotkeytext = "=";
			end
			actionButton:SetAttribute("showstates", "3");
			actionButton.laststate = actionButton:GetAttribute("showstates");
			stanceFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[3] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[3] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[3] == 0) then
				actionButton.anchor = 3;
				TrinityDockFrame1.anchors[3] = i;
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[3] = i;			
		else			
			actionButton.dock = 9;
			actionButton.hotkey = nil;
			actionButton.hotkeytext = "";		
			actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");			
			actionButton.laststate = actionButton:GetAttribute("showstates");
			normalFrame:SetAttribute("addchild", actionButton);
			getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
			if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
				getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;
				
			end
			getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;							
		end
		
	elseif (i>108 and i<121) then		
		
		actionButton.dock = 10;
		actionButton.hotkey = nil;
		actionButton.hotkeytext = "";				
		actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");		
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;	
		
	elseif (i>120 and i<127) then					
		
		actionButton.dock = 11;
		TrinityMiscBars["bags"] = actionButton.dock; 
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					
	
	elseif (i>126 and i<135) then					
		
		actionButton.dock = 12;	
		TrinityMiscBars["menu"] = actionButton.dock; 
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;				

	elseif (i>134 and i<145) then					
		
		actionButton.dock = 13;
		TrinityMiscBars["pet"] = actionButton.dock; 
		actionButton:SetAttribute("showstates", "0");
		actionButton.laststate = actionButton:GetAttribute("showstates");
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;					

	elseif (i>144 and i<155) then							
	
		actionButton.dock = 14;
		TrinityMiscBars["form"] = actionButton.dock;	
		actionButton.laststate = actionButton:GetAttribute("showstates");		
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = GetNumShapeshiftForms();		
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;	
	elseif (i==155) then
	
		actionButton.dock = 15;
		TrinityMiscBars["cast"] = actionButton.dock;	
		actionButton.laststate = actionButton:GetAttribute("showstates");		
		normalFrame:SetAttribute("addchild", actionButton);
		getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] = getglobal("TrinityDockFrame"..actionButton.dock).buttonCount[0] + 1;
		if (getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] == 0) then
			getglobal("TrinityDockFrame"..actionButton.dock).anchors[0] = i;				
		end
		getglobal("TrinityDockFrame"..actionButton.dock).lastDocked[0] = i;			
	end	
end

-- This functions main purpose is to initialize the layout on a first run
function TrinityUpdateDockPostions(reset)

	local dockFrameHeight;
	
	local anchor = "BOTTOM";
	local relTo = "UIParent";
	local relPoint = "BOTTOM";
	local x = 0;
	local y = 30;	
	
	if (reset) then
	
		dockFrameHeight = 50;
		
		for i=1,TrinityDockFrames do		
			local dockFrame = getglobal("TrinityDockFrame"..i);
			
			TrinityButtonDockDefaults(i, dockFrame);
			
			if (UnitClass("player") == TRINITY_DRUID or UnitClass("player") == TRINITY_WARRIOR or UnitClass("player") == TRINITY_ROGUE or UnitClass("player") == TRINITY_PRIEST) then
				if (i==1) then
					dockFrame.config["header"] = "TrinityStanceButtons";					
					getglobal(dockFrame:GetName().."Ghost"):Hide();
				elseif (i==2) then
					dockFrame.config["header"] = "TrinityPagedButtons";					
					getglobal(dockFrame:GetName().."Ghost"):Hide();
				else
					dockFrame.config["header"] = "TrinityNormalButtons";					
				end			
			else
				if (i==1) then
					dockFrame.config["header"] = "TrinityPagedButtons";					
					getglobal(dockFrame:GetName().."Ghost"):Hide();
				else
					dockFrame.config["header"] = "TrinityNormalButtons";					
				end
			end					

			if (UnitClass("player") == TRINITY_DRUID) then
				TrinityCreateProwlCheck(i, dockFrame);
			end
		
			dockFrame:SetUserPlaced(false);		
			dockFrame:ClearAllPoints();			
			dockFrame:SetPoint(anchor, relTo, relPoint, x, y);
			dockFrame:SetUserPlaced(true);		
			y = y + dockFrameHeight;								
		end			
		
		for i=1,155 do
			local actionButton = getglobal("TrinityActionButton"..i);
			TrinityButtonDefaults(i, actionButton, TrinityStanceButtons, TrinityPagedButtons, TrinityNormalButtons)
		end		

		for i=1,TrinityDockFrames do		
			local dockFrame = getglobal("TrinityDockFrame"..i);
			TrinityMiscBarSetup(i, dockFrame);			
		end

		TrinityTempDockFrame.buttonIndex = {}
		for i=1,155 do
			TrinityTempDockFrame.buttonIndex[i] = 0;
		end
		TrinityTempDockFrame.buttonCount = 0;
		
		TrinityUpdateShapeshiftButtons();
		
		TrinityFirstRun = false;
	else	
		for i=1,TrinityDockFrames do		
			local dockFrame = getglobal("TrinityDockFrame"..i);					
					
			if (dockFrame.config["header"] == "TrinityStanceButtons") then								
				getglobal(dockFrame:GetName().."Ghost"):Hide();
				if (UnitClass("player") == TRINITY_DRUID) then
					TrinityCreateProwlCheck(i, dockFrame);
				end
			elseif (dockFrame.config["header"] == "TrinityPagedButtons") then				
				getglobal(dockFrame:GetName().."Ghost"):Hide();
			end
			
			TrinityMiscBarSetup(i, dockFrame);			

			dockFrame:SetUserPlaced(false);
			dockFrame:ClearAllPoints();			
			dockFrame:SetPoint("CENTER", relTo, "BOTTOMLEFT", dockFrame.centerx, dockFrame.centery);
			dockFrame:SetUserPlaced(true);
		end		
	end
end

function TrinityMiscBarSetup(i, dockFrame)

	if (i==TrinityMiscBars["bags"]) then
		dockFrame.config["header"] = "TrinityNormalButtons";				
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);				
		getglobal(dockFrame:GetName().."Add"):SetScript("OnClick", function() dockFrame.config["hide"] = 1 TrinityToggleHideShow(dockFrame, 1) TrinityUpdateDocking(this:GetParent():GetID()) end);
		getglobal(dockFrame:GetName().."Subtract"):SetScript("OnClick", function() dockFrame.config["hide"] = 0 TrinityToggleHideShow(dockFrame, 1) TrinityUpdateDocking(this:GetParent():GetID()) end);
		getglobal(dockFrame:GetName().."Add"):SetScript("OnUpdate", function() end);
		getglobal(dockFrame:GetName().."Subtract"):SetScript("OnUpdate", function() end);
		if (dockFrame.buttonCount[0] == 1) then
			MainMenuBarBackpackButton:SetScript("OnClick", function() OpenAllBags() end);
		else
			MainMenuBarBackpackButton:SetScript("OnClick", function() if (IsShiftKeyDown()) then OpenAllBags() else ToggleBackpack() end end);
		end
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
	elseif (i==TrinityMiscBars["menu"]) then
		dockFrame.config["header"] = "TrinityNormalButtons";				
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Add"):Hide();
		getglobal(dockFrame:GetName().."Subtract"):Hide();
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
	elseif (i==TrinityMiscBars["pet"]) then
		dockFrame.config["header"] = "TrinityNormalButtons";				
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Add"):Hide();
		getglobal(dockFrame:GetName().."Subtract"):Hide();				
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
	elseif (i==TrinityMiscBars["form"]) then
		dockFrame.config["header"] = "TrinityNormalButtons";				
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Add"):Hide();
		getglobal(dockFrame:GetName().."Subtract"):Hide();				
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();		
	elseif (i==TrinityMiscBars["cast"]) then
		getglobal(dockFrame:GetName().."Close"):Show();
		getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);						
		getglobal(dockFrame:GetName().."Add"):SetScript("OnUpdate", function() TrinityAddOnUpdate(dockFrame, arg1) end);
		getglobal(dockFrame:GetName().."Subtract"):SetScript("OnUpdate", function() TrinitySubtractOnUpdate(dockFrame, arg1) end);		
		getglobal(dockFrame:GetName().."ShowGrid"):Hide();
		getglobal(dockFrame:GetName().."BarType"):Hide();
		getglobal(dockFrame:GetName().."Ghost"):Hide();
		if (not dockFrame.config["orientation"]) then
			dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation();
		else
			TrinityCastingBar:SetOrientation(dockFrame.config["orientation"]);
			TrinityCastingBarDummy:SetOrientation(dockFrame.config["orientation"]);
			TrinityCastingBarSetTextures(dockFrame.config["orientation"]);
		end
		if (not dockFrame.config["anchorwidth"]) then
			dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		else
			TrinityCastingBar:GetParent():SetWidth(dockFrame.config["anchorwidth"]);
			TrinityCastingBarDummy:GetParent():SetWidth(dockFrame.config["anchorwidth"]);
		end
		if (not dockFrame.config["anchorheight"]) then
			dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
		else
			TrinityCastingBar:GetParent():SetHeight(dockFrame.config["anchorheight"]);
			TrinityCastingBarDummy:GetParent():SetHeight(dockFrame.config["anchorheight"]);
		end
			
		TrinityCastingBarDummy:SetParent(getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]));		
		if (getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]).config["hide"] == 0) then
			TrinityCastingBarDummy:Show();
		else
			TrinityCastingBarDummy:Hide();
		end
		TrinityCastingBar:Hide();		
	end
end
-- A function to handle events
function TrinityButtons_OnEvent(self,event,...)

	if (event == "UPDATE_STEALTH") then
		TrinityUpdateDockingAfterEvent()
	end
	
	if (event == "VARIABLES_LOADED") then	
		TrinityCreateDockFrames();
		TrinityCreateButtons();		
		TrinityLoadSV();
	end
	
	if (event == "PLAYER_REGEN_DISABLED") then
		if (not TrinityDockBarsHide) then
			UIErrorsFrame:AddMessage("In Combat Lockdown - Hiding Docks", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			TrinityDockLockdown = true;
			TrinityDockBarsHide = true;
			TrinityButtonsHide = true;
			TrinityUpdateDocking()
		end
		
		
		for i=1,TrinityDockFrames do							
			if (getglobal("TrinityDockFrame"..i).config["ghost"] == 1) then
				local buttonList = {};	
				string.gsub(getglobal("TrinityDockFrame"..i).buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);
				for j=1,getn(buttonList) do
					getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates","0,1,2,3,4,5,6,7,8,9");
					getglobal("TrinityActionButton"..buttonList[j]):SetAlpha(getglobal("TrinityDockFrame"..i).config["alpha"]);
					getglobal("TrinityActionButton"..buttonList[j]):Show();
				end
			end
			getglobal("TrinityDockFrame"..i).config["vis"] = 1;
		end
		
		TrinityCombatLockdown = true;
	end
	
	if (event == "PLAYER_REGEN_ENABLED") then	
		if (TrinityDockLockdown) then
			UIErrorsFrame:AddMessage("Combat Lockdown Ended - Showing Docks", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
			TrinityDockLockdown = false;
			TrinityDockBarsHide = false;
			TrinityButtonsHide = false;
			TrinityUpdateDocking()
		end
		
		TrinityUpdateDockingAfterEvent()
		
		TrinityCombatLockdown = false;
	end

	if (event == "PLAYER_ENTERING_WORLD") then
		if (not TrinityPlayerEnteredWorld) then			
			if (TrinityMiscBars["form"] ~= 0) then
				if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["hide"] == 0) then
					TrinityUpdateShapeshiftButtons();
				end					
			end
			TrinityUpdateFormNames();
			TrinityUpdateDockPostions(TrinityFirstRun);			
			TrinityUpdateDocking();
			TrinityUpdateBindings();
			TrinitySwapTextures(TrinityButtonStyle);	
			TrinityPlayerEnteredWorld = true;		
		end
	end
	
	if (event == "PLAYER_AURAS_CHANGED") then		
		TrinityUpdateDockingAfterEvent()
	end

	if (event == "ACTIONBAR_PAGE_CHANGED") then				
		TrinityUpdateDockingAfterEvent()
	end

	if (event == "UPDATE_SHAPESHIFT_FORMS") then
		if (TrinityMiscBars["form"] ~= 0) then
			if (getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["hide"]) then
				TrinityUpdateShapeshiftButtons();
				if (not TrinityDockBarsHide) then
					TrinityUpdateDocking(TrinityMiscBars["form"]);
				end
			end
		end
	end
	
	if (event == "ACTIONBAR_SHOWGRID") then
		if (TrinityDockBarsHide) then
			TrinityButtonsHide = false;
			TrinityHideDocksButtons();
		end
	end
	
	if (event == "ACTIONBAR_HIDEGRID") then
		if (TrinityDockBarsHide) then 
			TrinityButtonsHide = true;			
			TrinityHideDocksButtons();
		end
	end
end

function TrinityUpdateDockingAfterEvent()

	if (not TrinityCombatLockdown and TrinityDockBarsHide == false) then
		for i=1,TrinityDockFrames do
			if (getglobal("TrinityDockFrame"..i).config["header"] == "TrinityStanceButtons") then
				TrinityUpdateDockFrames(getglobal("TrinityDockFrame"..i), GetShapeshiftForm(), 36, 40, 36, 2);			
			elseif (getglobal("TrinityDockFrame"..i).config["header"] == "TrinityPagedButtons") then
				TrinityUpdateDockFrames(getglobal("TrinityDockFrame"..i), GetActionBarPage(), 36, 40, 36, 3);			
			end
		end				
	end	
end

function TrinityUpdateFormNames()

 	for i=1,GetNumShapeshiftForms() do 		 		
 		local _, formName, _ = GetShapeshiftFormInfo(i); 		
 		TrinityForms[formName] = i; 		
 	end
 end


function TrinityUpdateShapeshiftButtons()	

	TrinityUpdateFormNames();
 	
 	if (UnitClass("player") == TRINITY_DRUID) then
 		TrinityForms["Prowl"] = GetNumShapeshiftForms()+1;
 	end

	getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).buttonCount[0] = 0;		

	for i=145,154 do
		getglobal("TrinityActionButton"..i):SetAttribute("showstates", "10-99");		
		getglobal("TrinityActionButton"..i).dock = 99;		
		TrinityTempDockFrame.buttonIndex[getglobal("TrinityActionButton"..i):GetID()] = 1;
	end
	
	if (GetNumShapeshiftForms() > 0) then
		for i=145,144+GetNumShapeshiftForms() do			
			getglobal("TrinityActionButton"..i):SetAttribute("showstates", "0");			
			getglobal("TrinityActionButton"..i).dock = TrinityMiscBars["form"];			
			getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).buttonCount[0] = getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).buttonCount[0] + 1;
			TrinityTempDockFrame.buttonIndex[getglobal("TrinityActionButton"..i):GetID()] = 0;
		end 
	end

	SecureStateHeader_Refresh(TrinityNormalButtons, "0");
end

function TrinityChangeBarType(frame)

	if (frame.config["header"] == "TrinityStanceButtons") then
		frame.config["header"] = "TrinityPagedButtons"
		frame.config["ghost"] = nil;	
		frame.config["prowl"] = nil;
		getglobal(frame:GetName().."Ghost"):Hide();
		if (getglobal("TrinityProwlOption"..frame:GetID()) and UnitClass("player") == TRINITY_DRUID) then
			getglobal("TrinityProwlOption"..frame:GetID()):SetAttribute("showstates", "10-99");		
		end
		for i=0,9 do
			local buttonList = {};
			string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
			for j=1,getn(buttonList) do
				if (i<=5) then
					TrinityPagedButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));
					if (UnitClass("player") == TRINITY_WARRIOR) then
						getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", tostring(i));
						frame.buttonCount[i] = frame.buttonCount[i] - 1;				
						frame.buttonCount[i] = frame.buttonCount[i] + 1;				
						if (frame.buttonCount[i] <= 0) then
							frame.anchors[i] = frame.anchors[i];
							frame.lastDocked[i] = frame.lastDocked[i];						
							frame.anchors[i] = 0;
							frame.lastDocked[i] = 0;						
						end						
					else
						getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", tostring(i+1));
						frame.buttonCount[i] = frame.buttonCount[i] - 1;				
						frame.buttonCount[i+1] = frame.buttonCount[i+1] + 1;				
						if (frame.buttonCount[i] <= 0) then
							frame.anchors[i+1] = frame.anchors[i];
							frame.lastDocked[i+1] = frame.lastDocked[i];						
							frame.anchors[i] = 0;
							frame.lastDocked[i] = 0;						
						end
					end

				else
					getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", "10-99");		
					getglobal("TrinityActionButton"..buttonList[j]).dock = 99;
					TrinityTempDockFrame:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));
					TrinityTempDockFrame.buttonIndex[tonumber(buttonList[j])] = 1;
					TrinityTempDockFrame.buttonCount = TrinityTempDockFrame.buttonCount + 1;		
					frame.buttonCount[i] = frame.buttonCount[i] - 1;				
					if (frame.buttonCount[i] <= 0) then
						frame.anchors[i] = 0;
						frame.lastDocked[i] = 0;						
					end
				end
			end
		end				
		
	elseif (frame.config["header"] == "TrinityPagedButtons") then	
		frame.config["header"] = "TrinityNormalButtons"
		frame.config["ghost"] = nil;	
		frame.config["prowl"] = nil;
		getglobal(frame:GetName().."Ghost"):Show();
		if (getglobal("TrinityProwlOption"..frame:GetID()) and UnitClass("player") == TRINITY_DRUID) then
			getglobal("TrinityProwlOption"..frame:GetID()):SetAttribute("showstates", "10-99");		
		end
		for i=0,9 do
			local buttonList = {};	
			string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
			for j=1,getn(buttonList) do
				if (i==1) then
					TrinityNormalButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));
					getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", "0");
					frame.buttonCount[i] = frame.buttonCount[i] - 1;				
					frame.buttonCount[0] = frame.buttonCount[0] + 1;				
					if (frame.buttonCount[i] <= 0) then
						frame.anchors[0] = frame.anchors[i];
						frame.lastDocked[0] = frame.lastDocked[i];						
						frame.anchors[i] = 0;
						frame.lastDocked[i] = 0;						
					end
				else
					getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", "10-99");		
					getglobal("TrinityActionButton"..buttonList[j]).dock = 99;
					TrinityTempDockFrame:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));
					TrinityTempDockFrame.buttonIndex[tonumber(buttonList[j])] = 1;
					TrinityTempDockFrame.buttonCount = TrinityTempDockFrame.buttonCount + 1;		
					frame.buttonCount[i] = frame.buttonCount[i] - 1;				
					if (frame.buttonCount[i] <= 0) then
						frame.anchors[i] = 0;
						frame.lastDocked[i] = 0;						
					end
				end					
			end
		end			
		
	elseif (frame.config["header"] == "TrinityNormalButtons") then	
		frame.config["header"] = "TrinityStanceButtons"
		frame.config["ghost"] = nil;	
		frame.config["prowl"] = nil;
		getglobal(frame:GetName().."Ghost"):Hide();
		if (getglobal("TrinityProwlOption"..frame:GetID()) and UnitClass("player") == TRINITY_DRUID) then
			getglobal("TrinityProwlOption"..frame:GetID()):SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));		
		end
		for i=0,9 do
			local buttonList = {};	
			string.gsub(frame.buttonList[i], "%d+", function (btn) table.insert(buttonList, btn) end);
			for j=1,getn(buttonList) do
				if (i==0) then
					TrinityStanceButtons:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));
					if (UnitClass("player") == TRINITY_WARRIOR) then
						getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", "1");
						frame.buttonCount[i] = frame.buttonCount[i] - 1;				
						frame.buttonCount[1] = frame.buttonCount[1] + 1;				
						if (frame.buttonCount[i] <= 0) then
							frame.buttonCount[i] = 0;
							frame.anchors[1] = frame.anchors[i];
							frame.lastDocked[1] = frame.lastDocked[i];						
							frame.anchors[i] = 0;
							frame.lastDocked[i] = 0;						
						end
					else
						getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", TrinityClassShowStates);
						frame.buttonCount[i] = frame.buttonCount[i] - 1;				
						frame.buttonCount[0] = frame.buttonCount[0] + 1;				
						if (frame.buttonCount[i] <= 0) then
							frame.buttonCount[i] = 0;
							frame.anchors[0] = frame.anchors[i];
							frame.lastDocked[0] = frame.lastDocked[i];						
							frame.anchors[i] = 0;
							frame.lastDocked[i] = 0;						
						end
					end
				else
					getglobal("TrinityActionButton"..buttonList[j]):SetAttribute("showstates", "10-99");		
					getglobal("TrinityActionButton"..buttonList[j]).dock = 99;
					TrinityTempDockFrame:SetAttribute("addchild", getglobal("TrinityActionButton"..buttonList[j]));
					TrinityTempDockFrame.buttonIndex[tonumber(buttonList[j])] = 1;
					TrinityTempDockFrame.buttonCount = TrinityTempDockFrame.buttonCount + 1;		
					frame.buttonCount[i] = frame.buttonCount[i] - 1;				
					if (frame.buttonCount[i] == 0) then
						frame.anchors[i] = 0;
						frame.lastDocked[i] = 0;						
					end
				end					
			end
		end		
	end
end

function TrinityGetStance(frame)

	local stance;

	if (frame.config["header"] == "TrinityStanceButtons") then
		if (IsStealthed() and UnitClass("player") == TRINITY_DRUID and GetShapeshiftForm() == TrinityForms["Cat Form"] and frame.config["prowl"]) then
			stance = TrinityForms["Prowl"];		
		else
			stance = GetShapeshiftForm();
		end		
	elseif (frame.config["header"] == "TrinityPagedButtons") then
		stance = GetActionBarPage();
	else
		stance = 0;
	end	
	
	return stance;
end

-- Function to change the arrangment of buttons
function TrinityChangeShape(frame, dir)

	frame.elapsed = 0;
	
	if (dir == "left") then
		frame.config["shape"] = frame.config["shape"] - 1;
		if (frame.config["shape"] < 0) then
			frame.config["shape"] = TrinityMaxDockShapes
		end
	elseif (dir == "right") then
		frame.config["shape"] = frame.config["shape"] + 1;
		if (frame.config["shape"] > TrinityMaxDockShapes) then
			frame.config["shape"] = 0;
		end
	end
end

-- Function to change the size of buttons
function TrinityUpdateScale(frame, action)
	
	frame.elapsed = 0;
	
	if (action == "up") then
		frame.config["scale"] = frame.config["scale"] + 0.01;
		if (frame.config["scale"] > 2) then
			frame.config["scale"] = 2;
		end
	else
		frame.config["scale"] = frame.config["scale"] - 0.01;
		if (frame.config["scale"] < 0.2) then
			frame.config["scale"] = 0.2;
		end
	end	
end

-- Function to change the opacity of buttons.
function TrinityUpdateAlpha(frame, action)
	
	if (action == "up") then
		frame.config["alpha"] = frame.config["alpha"] + 0.05;
		if (frame.config["alpha"] > 1) then
			frame.config["alpha"] = 1;
		end
	else
		frame.config["alpha"] = frame.config["alpha"] - 0.05;
		if (frame.config["alpha"] < 0.1) then
			frame.config["alpha"] = 0.1;
		end
	end	
end

function TrinityAddOnUpdate(frame, elapsed)	

	this.elapsed = this.elapsed + elapsed;
	frame.count = frame.count + elapsed

	if (MouseIsOver(this)) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);			
		GameTooltip:SetText("Click to increase casting bar width", 1.0, 1.0, 1.0);
		GameTooltip:Show();
	end
	if ( this:GetButtonState() == "PUSHED" and this.elapsed > 0.15) then
		TrinityCastingBarWidth(frame, "add")
		TrinityUpdateDocking(this:GetParent():GetID());
		this.elapsed = 0;
		PlaySound("UChatScrollButton");
	end
end

function TrinitySubtractOnUpdate(frame, elapsed)

	this.elapsed = this.elapsed + elapsed;
	frame.count = frame.count + elapsed

	if (MouseIsOver(this)) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);			
		GameTooltip:SetText("Click to decrease casting bar width", 1.0, 1.0, 1.0);
		GameTooltip:Show();
	end
	if ( this:GetButtonState() == "PUSHED" and this.elapsed > 0.15) then			
		TrinityCastingBarWidth(frame, "subtract")
		TrinityUpdateDocking(this:GetParent():GetID());
		this.elapsed = 0;
		PlaySound("UChatScrollButton");
	end
end

function TrinityCastingBarWidth(frame, dir)

	frame.elapsed = 0;
	
	local increase = math.ceil(frame.count);
		
	local castBar = TrinityCastingBar:GetName()		
	
	if (frame.config["shape"] == 0) then
		
		if (dir == "add") then
		
			TrinityCastingBar:GetParent():SetWidth(TrinityCastingBar:GetParent():GetWidth()+increase)
		
		else
			if (TrinityCastingBar:GetParent():GetWidth()-increase > 10) then
				TrinityCastingBar:GetParent():SetWidth(TrinityCastingBar:GetParent():GetWidth()-increase)		
			else
				TrinityCastingBar:GetParent():SetWidth(10)		
			end	
		end
		
		frame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		frame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
		
	elseif (frame.config["shape"] == 1) then
		
		if (dir == "add") then
		
			TrinityCastingBar:GetParent():SetHeight(TrinityCastingBar:GetParent():GetHeight()+increase)

		else
			if (TrinityCastingBar:GetParent():GetHeight()-increase > 10) then
				TrinityCastingBar:GetParent():SetHeight(TrinityCastingBar:GetParent():GetHeight()-increase)
			else
				TrinityCastingBar:GetParent():SetHeight(10)
			end
		end
		
		frame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		frame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
	end
end

function TrinityCastingBarSetTextures(orient)

	local castBar = TrinityCastingBar:GetName()				

	if (orient == "HORIZONTAL") then

		getglobal(castBar):SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
		TrinityCastingBarDummy:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")				
		getglobal(castBar .. "Spark"):SetHeight(32);
		getglobal(castBar .. "Border"):SetTexture("Interface\\Tooltips\\UI-StatusBar-Border");
		TrinityCastingBarDummyBorder:SetTexture("Interface\\Tooltips\\UI-StatusBar-Border");
		getglobal(castBar .. "Flash"):SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\FlashH");						
		getglobal(castBar .. "Text"):SetFont("Fonts\\FRIZQT__.TTF", 12);
		
		getglobal(castBar .. "Border"):SetPoint("TOPLEFT", -8, 2);
		getglobal(castBar .. "Border"):SetPoint("BOTTOMRIGHT", 8, -2);
		TrinityCastingBarDummyBorder:SetPoint("TOPLEFT", -8, 2);
		TrinityCastingBarDummyBorder:SetPoint("BOTTOMRIGHT", 8, -2);
		getglobal(castBar .. "Flash"):SetPoint("TOPLEFT", -8, 2);
		getglobal(castBar .. "Flash"):SetPoint("BOTTOMRIGHT", 8, -2);
		getglobal(castBar .. "Text"):SetPoint("TOPLEFT", -8, 2);
		getglobal(castBar .. "Text"):SetPoint("BOTTOMRIGHT", 8, -2);		
	end
	
	if (orient == "VERTICAL") then
		
		getglobal(castBar):SetStatusBarTexture("Interface\\AddOns\\TrinityButtons\\Images\\BarFill2V")
		TrinityCastingBarDummy:SetStatusBarTexture("Interface\\AddOns\\TrinityButtons\\Images\\BarFill2V")
		getglobal(castBar .. "Spark"):SetHeight(10);
		getglobal(castBar .. "Border"):SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\UI-StatusBar-BorderV.tga");		
		TrinityCastingBarDummyBorder:SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\UI-StatusBar-BorderV.tga");
		getglobal(castBar .. "Flash"):SetTexture("Interface\\AddOns\\TrinityButtons\\Images\\FlashV.tga");	
		getglobal(castBar .. "Text"):SetFont("Fonts\\ARIALN.TTF", 12);
		
		getglobal(castBar .. "Border"):SetPoint("TOPLEFT", -2, 8);
		getglobal(castBar .. "Border"):SetPoint("BOTTOMRIGHT", 2, -8);
		TrinityCastingBarDummyBorder:SetPoint("TOPLEFT", -2, 8);
		TrinityCastingBarDummyBorder:SetPoint("BOTTOMRIGHT", 2, -8);
		getglobal(castBar .. "Flash"):SetPoint("TOPLEFT", -2, 8);
		getglobal(castBar .. "Flash"):SetPoint("BOTTOMRIGHT", 2, -8);
		getglobal(castBar .. "Text"):SetPoint("TOPLEFT", -2, 8);
		getglobal(castBar .. "Text"):SetPoint("BOTTOMRIGHT", 2, -8);				
	end
end


function TrinityCastingBarOrientation(dockFrame)

	local castBar = TrinityCastingBar:GetName()				
	local width, height;		

	if (dockFrame.config["anchorwidth"] == 0 or not dockFrame.config["anchorwidth"]) then
		width = TrinityCastingBar:GetParent():GetWidth()
	else
		width = dockFrame.config["anchorwidth"];
	end
	
	if (dockFrame.config["anchorheight"] == 0 or not dockFrame.config["anchorheight"]) then
		height = TrinityCastingBar:GetParent():GetHeight()	 
	else
		height = dockFrame.config["anchorheight"];
	end
	 
	if ( (mod(dockFrame.config["shape"],2) == 0 and dockFrame.config["orientation"] == "VERTICAL")) then 				
	
		getglobal(castBar):SetOrientation("HORIZONTAL");
		TrinityCastingBarDummy:SetOrientation("HORIZONTAL");
		TrinityCastingBarSetTextures("HORIZONTAL");
		
		TrinityCastingBar:GetParent():SetWidth(height)	
		TrinityCastingBar:GetParent():SetHeight(width/0.8)
		
		dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();
		dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation() 
		dockFrame.config["shape"] = 0;
	end
		
	if ((mod(dockFrame.config["shape"],2) ~= 0 and dockFrame.config["orientation"] == "HORIZONTAL")) then
		
		getglobal(castBar):SetOrientation("VERTICAL");
		TrinityCastingBarDummy:SetOrientation("VERTICAL");
		TrinityCastingBarSetTextures("VERTICAL");
		
		TrinityCastingBar:GetParent():SetWidth(height*0.8)
		TrinityCastingBar:GetParent():SetHeight(width)

		dockFrame.config["anchorwidth"] = TrinityCastingBar:GetParent():GetWidth();
		dockFrame.config["anchorheight"] = TrinityCastingBar:GetParent():GetHeight();	
		dockFrame.config["orientation"] = TrinityCastingBar:GetOrientation() 
		dockFrame.config["shape"] = 1;
	end	
end

function TrinityUpdateRows(frame, action)

	frame.elapsed = 0;
	
	if (action == "up") then
	
		stance = TrinityGetStance(frame);

		frame.config["columns"] = frame.config["columns"] + 1;
		if (frame.config["columns"] > frame.buttonCount[stance]) then
			frame.config["columns"] = frame.buttonCount[stance];
		end
	else
		frame.config["columns"] = frame.config["columns"] - 1;
		if (frame.config["columns"] < 2) then
			frame.config["columns"] = 2;
		end
	end	
end

function TrinityToggleHideShow(dockFrame, offset)

	if (dockFrame.config["hide"] == 0) then		
		if (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			TrinityCastingBarDummy:Hide();	
		end
		local buttonList = {};	
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);
		for i=1,getn(buttonList) do
			if (offset == 1) then
				if (buttonList[i] ~= "126") then
					getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","10-99");					
					getglobal("TrinityActionButton"..buttonList[i]).dock = 99;
					MainMenuBarBackpackButton:SetScript("OnClick", function() OpenAllBags() end);
				end
			else
				getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","10-99");				
				getglobal("TrinityActionButton"..buttonList[i]).dock = 99;
			end
		end
		if (offset == 1) then
			dockFrame.buttonCount[0] = 1;
			dockFrame.anchors[0] = 126;
			dockFrame.lastDocked[0] = 126;
		else					
			dockFrame.buttonCount[0] = 0;
			dockFrame.config["hide"] = 1;		
		end
	else		
		local buttonList = {};	
		local dockNum;
		
		if (dockFrame:GetID() == TrinityMiscBars["bags"]) then
			dockFrame.buttonList[0] = "121";			
			dockNum = TrinityMiscBars["bags"];
			for i=122,126 do
				dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
			end
		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			dockFrame.buttonList[0] = "127";
			dockNum = TrinityMiscBars["menu"];
			for i=128,134 do
				dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
			end		
		elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
			dockFrame.buttonList[0] = "135";			
			dockNum = TrinityMiscBars["pet"];
			for i=136,144 do
				dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
			end		
		elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
			dockFrame.buttonList[0] = "145";			
			dockNum = TrinityMiscBars["form"];
			for i=146,144+GetNumShapeshiftForms() do
				dockFrame.buttonList[0] = dockFrame.buttonList[0]..","..tostring(i);
			end			
		elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			dockFrame.buttonList[0] = "155";
			dockNum = TrinityMiscBars["cast"];
			TrinityCastingBarDummy:Show();
		end
		
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);			
		for i=1,getn(buttonList) do
			if (offset == 1) then
				MainMenuBarBackpackButton:SetScript("OnClick", function() if (IsShiftKeyDown()) then OpenAllBags() else ToggleBackpack() end end);
			end			
			getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","0");						
			getglobal("TrinityActionButton"..buttonList[i]).dock = dockNum;
			dockFrame.lastDocked[0] = tonumber(buttonList[i]);
		end
		dockFrame.buttonCount[0] = getn(buttonList);
		dockFrame.anchors[0] = tonumber(buttonList[1]);
		if (offset ~= 1) then
			dockFrame.config["hide"] = 0;		
		end
	end
end

-- Function to add a button to a docking frame.
function TrinityAddButton(frame)

	local stance;
	
	frame.elapsed = 0;
	
	stance = TrinityGetStance(frame);

	for i=1,120 do
	
		actionButton = getglobal("TrinityActionButton"..i);
	
		if (TrinityTempDockFrame.buttonIndex[i] == 1) then				
			actionButton.dock = frame:GetID();
			frame.buttonCount[stance] = frame.buttonCount[stance] + 1;
			TrinityTempDockFrame.buttonIndex[i] = 0;			
			TrinityTempDockFrame.buttonCount = TrinityTempDockFrame.buttonCount - 1;
		
			if (stance == 0) then
				actionButton:SetAttribute("showstates", TrinityClassShowStates);
				if (frame.anchors[0] > i) then
					actionButton.anchor = 0;						
					getglobal("TrinityActionButton"..frame.anchors[0]).anchor = 99;
					frame.anchors[0] = i;
				end		
			elseif (stance == 1) then
				actionButton:SetAttribute("showstates", "1");
				if (frame.anchors[1] > i) then
					actionButton.anchor = 1;						
					getglobal("TrinityActionButton"..frame.anchors[1]).anchor = 99;
					frame.anchors[1] = i;
				end
			elseif (stance == 2) then
				actionButton:SetAttribute("showstates", "2");
				if (frame.anchors[2] > i) then
					actionButton.anchor = 2;						
					getglobal("TrinityActionButton"..frame.anchors[2]).anchor = 99;
					frame.anchors[2] = i;
				end
			elseif (stance == 3) then
				actionButton:SetAttribute("showstates", "3");
				if (frame.anchors[3] > i) then
					actionButton.anchor = 3;						
					getglobal("TrinityActionButton"..frame.anchors[3]).anchor = 99;
					frame.anchors[3] = i;
				end
			elseif (stance == 4) then
				actionButton:SetAttribute("showstates", "4");
				if (frame.anchors[4] > i) then
					actionButton.anchor = 4;						
					getglobal("TrinityActionButton"..frame.anchors[4]).anchor = 99;
					frame.anchors[4] = i;
				end		
			elseif (stance == 5) then
				actionButton:SetAttribute("showstates", "5");
				if (frame.anchors[5] > i) then
					actionButton.anchor = 5;
					getglobal("TrinityActionButton"..frame.anchors[5]).anchor = 99;
					frame.anchors[5] = i;
				end
			elseif (stance == 6) then
				actionButton:SetAttribute("showstates", "6");
				if (frame.anchors[6] > i) then
					actionButton.anchor = 6;
					getglobal("TrinityActionButton"..frame.anchors[6]).anchor = 99;
					frame.anchors[6] = i;
				end
			elseif (stance == 7) then
				actionButton:SetAttribute("showstates", "7");
				if (frame.anchors[7] > i) then
					actionButton.anchor = 7;
					getglobal("TrinityActionButton"..frame.anchors[7]).anchor = 99;
					frame.anchors[7] = i;
				end
			elseif (stance == 8) then
				actionButton:SetAttribute("showstates", "8");
				if (frame.anchors[8] > i) then
					actionButton.anchor = 8;
					getglobal("TrinityActionButton"..frame.anchors[8]).anchor = 99;
					frame.anchors[8] = i;
				end
			elseif (stance == 9) then
				actionButton:SetAttribute("showstates", "9");
				if (frame.anchors[9] > i) then
					actionButton.anchor = 9;
					getglobal("TrinityActionButton"..frame.anchors[9]).anchor = 99;
					frame.anchors[9] = i;
				end
			else					
				actionButton:SetAttribute("showstates", "0,1,2,3,4,5,6,7,8,9");
			end
			
			getglobal(frame.config["header"]):SetAttribute("addchild", actionButton);	
			
			if (frame.buttonCount[stance] == 1) then					
				frame.anchors[stance] = i;
			end
			
			frame.lastDocked[stance] = i;			
						
			return;
		end		
	end
	
	UIErrorsFrame:AddMessage("All buttons are being used, no available buttons found.\nRemove buttons from one bar to add to another.", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);
end

-- Function to remove a button from a docking frame.
function TrinitySubtractButtons(frame, all)

	local stance;
	
	frame.elapsed = 0;

	stance = TrinityGetStance(frame);
	
	if (frame.buttonCount[stance] < 1) then
		frame.anchors[stance] = 0;
		return;
	end
	
	if (frame.lastDocked[stance] > 120) then
		return;
	end
	
	local count = 1;
	
	if (all) then
		count = frame.buttonCount[stance];
	end
	
	for i=1,count do	
	
		getglobal("TrinityActionButton"..frame.lastDocked[stance]):SetAttribute("showstates", "10-99");		
		getglobal("TrinityActionButton"..frame.lastDocked[stance]).dock = 99;
		TrinityTempDockFrame:SetAttribute("addchild", getglobal("TrinityActionButton"..frame.lastDocked[stance]));
		TrinityTempDockFrame.buttonIndex[frame.lastDocked[stance]] = 1;
		TrinityTempDockFrame.buttonCount = TrinityTempDockFrame.buttonCount + 1;		
		frame.buttonCount[stance] = frame.buttonCount[stance] - 1;
				
		if (frame.buttonCount[stance] == 0) then
			frame.anchors[stance] = 0;
			frame.lastDocked[stance] = 0;
			return;
		end
		
		if (all) then
			for i=1,120 do
				if (getglobal("TrinityActionButton"..i).dock == frame:GetID()) then
					if (string.find(getglobal("TrinityActionButton"..i):GetAttribute("showstates"), tostring(stance))) then
						frame.lastDocked[stance] = i;							
					end					
				end
			end					
		end
	end	
end

function TrinityHideDocksButtons(startDock, endDock)

	if (TrinityButtonsHide) then
		for i=1,120 do		
			local actionButton = getglobal("TrinityActionButton"..i);
			
			if (not HasAction(i) and TrinityPlayerEnteredWorld
			    and TrinityTempDockFrame.buttonIndex[i] ~= 1
			    and actionButton:GetAttribute("showstates") ~= "10-99"
			    and not getglobal("TrinityDockFrame"..actionButton.dock.."ShowGrid"):GetChecked()
			    and not MouseIsOver(actionButton)) then
			    
				if (actionButton:GetAttribute("showstates") ~= "10-99") then
					actionButton.laststate = actionButton:GetAttribute("showstates");
				end
				actionButton:SetAttribute("showstates", "10-99");
			end
		end				
	else
		for i=1,120 do		
			local actionButton = getglobal("TrinityActionButton"..i);
			if (actionButton:GetAttribute("showstates") == "10-99" and TrinityTempDockFrame.buttonIndex[i] ~= 1) then				
				actionButton:SetAttribute("showstates", actionButton.laststate);
			end
		end			
	end	

	if (startDock and endDock) then
		if (TrinityDockBarsHide) then	
			for i=startDock,endDock do		
				local tempDockFrame = getglobal("TrinityDockFrame"..i);	
				tempDockFrame:Hide();
	
				if (getglobal("TrinityProwlOption"..i) and tempDockFrame.config["header"] == "TrinityStanceButtons" and UnitClass("player") == TRINITY_DRUID) then			
					getglobal("TrinityProwlOption"..i):SetAttribute("showstates", "10-99");
				end
			end		
		else
			for i=startDock,endDock do		
				local tempDockFrame = getglobal("TrinityDockFrame"..i);	
				tempDockFrame:Show();
				for i=0,9 do
					tempDockFrame.placed[i] = 0;
					tempDockFrame.buttonList[i] = "";
				end		
				if (getglobal("TrinityProwlOption"..i) and tempDockFrame.config["header"] == "TrinityStanceButtons" and UnitClass("player") == TRINITY_DRUID) then			
					getglobal("TrinityProwlOption"..i):SetAttribute("showstates", tostring(TrinityForms["Cat Form"]));			
				end
			end
		end
	else
		TrinitySaveButtonState();
		
		TrinityRefreshHeaders();	
	end
end

-- This is the main function that arranges the buttons based of dock frame settings.
function TrinityUpdateDocking(dockNumber)

	startDock = 1; endDock = TrinityDockFrames;
	
	if (dockNumber) then		
		startDock = dockNumber;
		endDock = dockNumber;
	end
	
	TrinityHideDocksButtons(startDock, endDock)

	for i=1,155 do		
		
		local actionButton = getglobal("TrinityActionButton"..i);
		getglobal(actionButton:GetName().."HotKey"):SetText(actionButton.hotkeytext);
		
		for i=startDock,endDock do		
		
			local stance = 0;	
			local dockFrame = getglobal("TrinityDockFrame"..i);
			local dockFrameName = getglobal("TrinityDockFrame"..i):GetName();
			local dockFrameScale = getglobal("TrinityDockFrame"..i.."Scale");			
			local width = actionButton:GetWidth();
			local height = 40;
			local pad = 0;

			if (dockFrame:GetID() == TrinityMiscBars["cast"] and actionButton.dock == TrinityMiscBars["cast"]) then	
				TrinityCastingBarOrientation(dockFrame)
				if (TrinityCastingBar:GetOrientation() == "VERTICAL") then					
					height = actionButton:GetHeight();	
				end			
			end
			
			if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
				width = 30;
				height = actionButton:GetHeight();
			end
			 
			if (actionButton.dock == i) then				
				
				actionButton:SetScale(dockFrame.config["scale"]);
				actionButton:SetAlpha(dockFrame.config["alpha"]);			
				
				if (actionButton:GetAttribute("showstates") == "10-99") then
					stance = tonumber(actionButton.laststate) or 0;					
				else
					stance = tonumber(actionButton:GetAttribute("showstates")) or 0;					
				end				
				
				if (dockFrame.anchors[stance] > actionButton:GetID() or dockFrame.anchors[stance] == 0) then
					dockFrame.anchors[stance] = actionButton:GetID();
				end			
				
				actionButton:ClearAllPoints();				
			
				if (dockFrame.anchors[stance] == actionButton:GetID()) then							
				
					if (dockFrame.config["shape"] == 0) then
						if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
							actionButton:SetPoint("LEFT", dockFrame:GetName(), "CENTER", -((width*(dockFrame.buttonCount[stance]-1))/2), -4);					
						else
							actionButton:SetPoint("LEFT", dockFrame:GetName(), "CENTER", -(((width*dockFrame.buttonCount[stance])+(TrinityButtonSpaceH*(dockFrame.buttonCount[stance]-1)))/2), 0);					
						end
						dockFrame.lastDocked[stance] = actionButton:GetID();
						dockFrame.buttonList[stance] = tostring(actionButton:GetID());						
					elseif (dockFrame.config["shape"] == 1) then
						actionButton:SetPoint("TOP", dockFrame:GetName(), "CENTER", 0, (((height*dockFrame.buttonCount[stance])+(TrinityButtonSpaceH*(dockFrame.buttonCount[stance]-1)))/2));						
						dockFrame.lastDocked[stance] = actionButton:GetID();
						dockFrame.buttonList[stance] = tostring(actionButton:GetID());
					elseif (dockFrame.config["shape"] == 2) then
						if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
							actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width)*((dockFrame.config["columns"]-0.5)/2)), (26)*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"])/2));
						else
							actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width+TrinityButtonSpaceH)*(dockFrame.config["columns"]/2)), (height)*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"])/2));
						end
						dockFrame.lastDocked[stance] = actionButton:GetID();							
						dockFrame.buttonList[stance] = tostring(actionButton:GetID());
						dockFrame.placed[stance] = 1;
						getglobal(dockFrame:GetName().."IncreaseRows"):Show();
						getglobal(dockFrame:GetName().."DecreaseRows"):Show();
						getglobal(dockFrame:GetName().."Columns"):Show();
						getglobal(dockFrame:GetName().."Rows"):Show();
					elseif (dockFrame.config["shape"] == 3) then
						dockFrame.placed[stance] = 90;
						local x = math.floor((width*(dockFrame.buttonCount[stance]/4))*(cos(dockFrame.placed[stance])));
						local y = math.floor((width*(dockFrame.buttonCount[stance]/4))*(sin(dockFrame.placed[stance])));
						actionButton:SetPoint("CENTER", dockFrame:GetName(), "CENTER", x, y);
						dockFrame.lastDocked[stance] = actionButton:GetID();						
						dockFrame.buttonList[stance] = tostring(actionButton:GetID());
					elseif (dockFrame.config["shape"] == 4) then
						dockFrame.placed[stance] = 180;
						local x = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(cos(dockFrame.placed[stance])));
						local y = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(sin(dockFrame.placed[stance])));
						actionButton:SetPoint("BOTTOM", dockFrame:GetName(), "BOTTOM", x, y);
						dockFrame.lastDocked[stance] = actionButton:GetID();						
						dockFrame.buttonList[stance] = tostring(actionButton:GetID());
					elseif (dockFrame.config["shape"] == 5) then
						dockFrame.placed[stance] = 180;
						local x = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(cos(dockFrame.placed[stance])));
						local y = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(sin(dockFrame.placed[stance])));
						actionButton:SetPoint("TOP", dockFrame:GetName(), "TOP", x, y);
						dockFrame.lastDocked[stance] = actionButton:GetID();						
						dockFrame.buttonList[stance] = tostring(actionButton:GetID());
					end
				else
					if (dockFrame.config["shape"] == 0) then
						actionButton:SetPoint("LEFT", getglobal("TrinityActionButton"..dockFrame.lastDocked[stance]), "RIGHT", TrinityButtonSpaceH, 0);							
						dockFrame.lastDocked[stance] = actionButton:GetID();
						dockFrame.buttonList[stance] = dockFrame.buttonList[stance]..","..tostring(actionButton:GetID());
					elseif (dockFrame.config["shape"] == 1) then
						actionButton:SetPoint("TOPLEFT", getglobal("TrinityActionButton"..dockFrame.lastDocked[stance]), "BOTTOMLEFT", 0, -(TrinityButtonSpaceH));
						dockFrame.lastDocked[stance] = actionButton:GetID();
						dockFrame.buttonList[stance] = dockFrame.buttonList[stance]..","..tostring(actionButton:GetID());
					elseif (dockFrame.config["shape"] == 2) then						
						if (dockFrame.placed[stance] == dockFrame.config["columns"]) then							
							dockFrame.buttonList[stance] = dockFrame.buttonList[stance]..","..tostring(actionButton:GetID());
							local _,count = string.gsub(dockFrame.buttonList[stance],",",",");						
							local multiplier = (math.ceil(count/dockFrame.config["columns"]));
							if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
								actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width)*((dockFrame.config["columns"]-0.5)/2)), (26)*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"])/2)-(((height+TrinityButtonSpaceH)*multiplier)));
							else
								actionButton:SetPoint("TOPLEFT", dockFrame:GetName(), "CENTER", -((width+TrinityButtonSpaceH)*(dockFrame.config["columns"]/2)), (height)*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"])/2)-(((height)*multiplier)));
							end
							dockFrame.lastDocked[stance] = actionButton:GetID();							
							dockFrame.placed[stance] = 1;
						else
							actionButton:SetPoint("LEFT", getglobal("TrinityActionButton"..dockFrame.lastDocked[stance]), "RIGHT", TrinityButtonSpaceH, 0);
							dockFrame.lastDocked[stance] = actionButton:GetID();
							dockFrame.buttonList[stance] = dockFrame.buttonList[stance]..","..tostring(actionButton:GetID());
							dockFrame.placed[stance] = dockFrame.placed[stance] + 1;								
						end
					elseif (dockFrame.config["shape"] == 3) then
						dockFrame.placed[stance] = dockFrame.placed[stance] - (360/dockFrame.buttonCount[stance]);							
						local x = math.floor((width*(dockFrame.buttonCount[stance]/4))*(cos(dockFrame.placed[stance])));
						local y = math.floor((width*(dockFrame.buttonCount[stance]/4))*(sin(dockFrame.placed[stance])));
						actionButton:SetPoint("CENTER", dockFrame:GetName(), "CENTER", x, y);
						dockFrame.lastDocked[stance] = actionButton:GetID();						
						dockFrame.buttonList[stance] = dockFrame.buttonList[stance]..","..tostring(actionButton:GetID());
					elseif (dockFrame.config["shape"] == 4) then
						dockFrame.placed[stance] = dockFrame.placed[stance] - (180/(dockFrame.buttonCount[stance]-1));							
						local x = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(cos(dockFrame.placed[stance])));
						local y = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(sin(dockFrame.placed[stance])));
						actionButton:SetPoint("BOTTOM", dockFrame:GetName(), "BOTTOM", x, y);
						dockFrame.lastDocked[stance] = actionButton:GetID();						
						dockFrame.buttonList[stance] = dockFrame.buttonList[stance]..","..tostring(actionButton:GetID());
					elseif (dockFrame.config["shape"] == 5) then
						dockFrame.placed[stance] = dockFrame.placed[stance] + (180/(dockFrame.buttonCount[stance]-1));							
						local x = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(cos(dockFrame.placed[stance])));
						local y = math.floor((width*(dockFrame.buttonCount[stance]/2.75))*(sin(dockFrame.placed[stance])));
						actionButton:SetPoint("TOP", dockFrame:GetName(), "TOP", x, y);
						dockFrame.lastDocked[stance] = actionButton:GetID();						
						dockFrame.buttonList[stance] = dockFrame.buttonList[stance]..","..tostring(actionButton:GetID());
					end						
				end
				
				if (TrinityDockBarsHide) then
					pad = 0;
				else
					if (width > 40) then
						pad = 40
					else
						pad = width;
					end
				end
		
				if (dockFrame.config["header"] == "TrinityStanceButtons") then
					stance = GetShapeshiftForm();
				elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
					stance = GetActionBarPage();
				end
				
				TrinityUpdateDockFrames(dockFrame, stance, width, height, pad, 6);			
			end
			
			if (dockFrame.buttonCount[stance] == 0 and dockFrame.config["header"] ~= "TrinityStanceButtons" and dockFrame.config["header"] ~= "TrinityPagedButtons") then
				TrinityUpdateDockFrames(dockFrame, stance, width, height, pad, 7);			
			end
		end		
	end
	
	TrinitySaveButtonState();	
	
	TrinityRefreshHeaders();
end

-- This function sizes the dockframe
function TrinityUpdateDockFrames(dockFrame, stance, width, height, pad, num)	

	getglobal(dockFrame:GetName().."Rows"):SetText(dockFrame.config["columns"]);	
	
	if (dockFrame.elapsed < 0.75) then
		dockFrame.update = true;
		return;
	end
	
	if (dockFrame.config["shape"] ~= 2) then
		getglobal(dockFrame:GetName().."IncreaseRows"):Hide();
		getglobal(dockFrame:GetName().."DecreaseRows"):Hide();
		getglobal(dockFrame:GetName().."Columns"):Hide();
		getglobal(dockFrame:GetName().."Rows"):Hide();
	end
	
	if (dockFrame.config["shape"] == 0) then
		getglobal(dockFrame:GetName().."ShowGrid"):SetPoint("TOPLEFT", 43, -1);
	else
		getglobal(dockFrame:GetName().."ShowGrid"):SetPoint("TOPLEFT", 23, -39);
	end

	dockFrame:SetUserPlaced(false);
	local x,y = dockFrame:GetCenter();		
	
	if (dockFrame.config["header"] == "TrinityStanceButtons" and UnitClass("player") == TRINITY_DRUID) then					
		if (stance == TrinityForms["Travel Form"] or
		    stance == TrinityForms["Aqautic Form"] or
		    stance == TrinityForms["Flight Form"]) then
			stance = 0;
		elseif (IsStealthed() and stance == TrinityForms["Cat Form"] and dockFrame.config["prowl"]) then
			stance = TrinityForms["Prowl"];
		end		
	end		
	
	if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
		pad = 18;
		height = 40;
	end

	if (dockFrame.buttonCount[stance] < 1) then
		width = 36; pad = 36; height = 40;
	end
	
	if (dockFrame.config["header"] == "TrinityStanceButtons") then
		getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Stance-"..GetShapeshiftForm());
		getglobal(dockFrame:GetName().."BarType"):SetWidth(50);
	elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
		getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Paged-"..GetActionBarPage());
		getglobal(dockFrame:GetName().."BarType"):SetWidth(50);
	elseif (dockFrame:GetID() == TrinityMiscBars["bags"]) then
		getglobal(dockFrame:GetName().."BarNumber"):SetText("Bags");
		getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);
	elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
		getglobal(dockFrame:GetName().."BarNumber"):SetText("Menu");
		getglobal(dockFrame:GetName().."BarNumber"):SetTextHeight(10);
	elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
		getglobal(dockFrame:GetName().."BarNumber"):SetText("PetBar");	
	elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
		getglobal(dockFrame:GetName().."BarNumber"):SetText("FormBar");
	elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
		getglobal(dockFrame:GetName().."BarNumber"):SetText("CastBar");	
		getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 42, 3);
	else	
		getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("Bar"..dockFrame:GetID());		
		getglobal(dockFrame:GetName().."BarType"):SetWidth(50);
	end
	
	if (dockFrame.config["shape"] == 0) then				
		dockFrame:SetWidth((((width+TrinityButtonSpaceH)*dockFrame.buttonCount[stance])*dockFrame.config["scale"])+(pad*4));		
		dockFrame:SetHeight(height);				
	elseif (dockFrame.config["shape"] == 1) then
		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("S-"..GetShapeshiftForm());
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);
		elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
			getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("P-"..GetActionBarPage());
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);
		elseif (dockFrame:GetID() == TrinityMiscBars["bags"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Bags");
			getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 19, -34);
		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Menu");
			getglobal(dockFrame:GetName().."BarNumber"):SetTextHeight(9);
			width = 40;
		elseif (dockFrame:GetID() == TrinityMiscBars["pet"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Pet");	
			width = 36;
		elseif (dockFrame:GetID() == TrinityMiscBars["form"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Form");		
			width = 36;
		elseif (dockFrame:GetID() == TrinityMiscBars["cast"]) then
			getglobal(dockFrame:GetName().."BarNumber"):SetText("Cast");		
			getglobal(dockFrame:GetName().."Close"):SetPoint("TOPLEFT", 19, -34);
			width = 36;
			pad = 45;
		else	
			getglobal(dockFrame:GetName().."BarType"):SetWidth(28);
		end
		dockFrame:SetWidth(width*1.4);
		dockFrame:SetHeight((((height+TrinityButtonSpaceH)*(dockFrame.buttonCount[stance]))*dockFrame.config["scale"])+(pad*3));			
	elseif (dockFrame.config["shape"] == 2) then
		if (dockFrame.config["header"] == "TrinityStanceButtons") then
			getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("S-"..GetShapeshiftForm());
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);
		elseif (dockFrame.config["header"] == "TrinityPagedButtons") then
			getglobal(dockFrame:GetName().."BarType".."BarNumber"):SetText("P-"..GetActionBarPage());
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);
		else	
			getglobal(dockFrame:GetName().."BarType"):SetWidth(36);
		end		
		if (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			dockFrame:SetWidth((((width)*dockFrame.config["columns"])*dockFrame.config["scale"])+(pad*5));
		else
			dockFrame:SetWidth((((width+TrinityButtonSpaceH)*dockFrame.config["columns"])*dockFrame.config["scale"])+(pad*3.25));
		end
		if (math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"]) <= 1) then
			dockFrame:SetHeight((height+TrinityButtonSpaceH)*2);			
		elseif (dockFrame:GetID() == TrinityMiscBars["menu"]) then
			dockFrame:SetHeight(36*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"]))*dockFrame.config["scale"]);
		else
			dockFrame:SetHeight((height+TrinityButtonSpaceH)*(math.ceil(dockFrame.buttonCount[stance]/dockFrame.config["columns"]))*dockFrame.config["scale"]);
		end
	elseif (dockFrame.config["shape"] == 3) then
		dockFrame:SetWidth(((width*((dockFrame.buttonCount[stance]/2)+1))*dockFrame.config["scale"])+(pad));
		dockFrame:SetHeight(((height*((dockFrame.buttonCount[stance]/2)+1))*dockFrame.config["scale"])+(pad));
	elseif (dockFrame.config["shape"] == 4) then
		dockFrame:SetWidth((width*(dockFrame.buttonCount[stance]/2.75)*dockFrame.config["scale"]*2)+width+(pad*3));
		dockFrame:SetHeight((height*(dockFrame.buttonCount[stance]/2.75)*dockFrame.config["scale"])+(height/2));
	elseif (dockFrame.config["shape"] == 5) then
		dockFrame:SetWidth((width*(dockFrame.buttonCount[stance]/2.75)*dockFrame.config["scale"]*2)+width+(pad*3));
		dockFrame:SetHeight((height*(dockFrame.buttonCount[stance]/2.75)*dockFrame.config["scale"])+(height/2));	
	end
	
	if (TrinityPlayerEnteredWorld) then		
		dockFrame:ClearAllPoints();
		dockFrame:SetPoint("CENTER","UIParent", "BOTTOMLEFT", x, y);
		dockFrame:SetUserPlaced(true);
	end	
	
	return;

end

function TrinityRefreshHeaders()

	if (IsStealthed() and UnitClass("player") == TRINITY_DRUID and GetShapeshiftForm() == TrinityForms["Cat Form"] and TrinityProwlBarActive) then
		SecureStateHeader_Refresh(TrinityStanceButtons, "6");			
	else		
		SecureStateHeader_Refresh(TrinityStanceButtons, tostring(GetShapeshiftForm()));			
	end	

	SecureStateHeader_Refresh(TrinityPagedButtons, tostring(GetActionBarPage()));	

	SecureStateHeader_Refresh(TrinityNormalButtons, "0");
	
	SecureStateHeader_Refresh(TrinityTempDockFrame, "100");	
end

-- A function to hide/show buttons on mouseover
function TrinityGhostUpdate(dockFrame)


	if (MouseIsOver(dockFrame) and dockFrame.config["vis"] == 0 and dockFrame.config["hide"] == 0) then		
		local buttonList = {};	
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);
		for i=1,getn(buttonList) do			
			getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates", getglobal("TrinityActionButton"..buttonList[i]).laststate);			
			getglobal("TrinityActionButton"..buttonList[i]):SetAlpha(dockFrame.config["alpha"]);
			if (HasAction(tonumber(buttonList[i]))) then
				getglobal("TrinityActionButton"..buttonList[i]):Show();
			end
		end			
		dockFrame.config["vis"] = 1;		
	end
	
	if (not MouseIsOver(dockFrame) and dockFrame.config["vis"] == 1) then		
		local buttonList = {};	
		string.gsub(dockFrame.buttonList[0], "%d+", function (btn) table.insert(buttonList, btn) end);			
		for i=1,getn(buttonList) do
			if (getglobal("TrinityActionButton"..buttonList[i]):GetAttribute("showstates") ~= "10-99") then
				getglobal("TrinityActionButton"..buttonList[i]).laststate = getglobal("TrinityActionButton"..buttonList[i]):GetAttribute("showstates");
			end
			getglobal("TrinityActionButton"..buttonList[i]):SetAttribute("showstates","10-99");
			getglobal("TrinityActionButton"..buttonList[i]):SetAlpha(0);
			if (HasAction(tonumber(buttonList[i]))) then
				getglobal("TrinityActionButton"..buttonList[i]):Show();
			end
		end			
		dockFrame.config["vis"] = 0;		
	end
end

-- This function updates each button with visual elements
function Trinity_UpdateButton()
	
	local icon = getglobal(this:GetName().."IconFrame".."Icon");
	local normalTexture = getglobal(this:GetName().."NormalTexture");
	local cooldown = getglobal(this:GetName().."IconFrame".."Cooldown");
	local border = getglobal(this:GetName().."Border");
	local flashTexture = getglobal(this:GetName().."Flash");
	local count = getglobal(this:GetName().."Count");
	local id = this:GetID();
	
	local isUsable, notEnoughMana = IsUsableAction(id);
	local start, duration, enable = GetActionCooldown(id);
	
	if ( isUsable ) then
		if ( IsActionInRange(id) == 0) then
			icon:SetVertexColor(1.0, 0.1, 0.1);			
		else
			icon:SetVertexColor(1.0, 1.0, 1.0);			
		end
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.5, 0.5, 1.0);		
	else
		icon:SetVertexColor(0.4, 0.4, 0.4);		
	end
     		
	if ( HasAction(id) ) then
		local texture = GetActionTexture(id);
		icon:SetTexture(texture);
		if (TrinityButtonStyle == 1) then
			this:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		end
		normalTexture:SetVertexColor(1,1,1,1);
		icon:Show();		
	else	
		if (TrinityButtonStyle == 1) then		
			this:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");					
		end
		normalTexture:SetVertexColor(1,1,1,0.35);
		icon:Hide();
	end
	
	if ( IsEquippedAction(id) ) then
		border:SetVertexColor(0, 1.0, 0, 0.5);
		border:Show();
	else
		border:Hide();
	end
	
	
	if ( IsConsumableAction(id) ) then
		count:SetText(GetActionCount(id));
	else
		count:SetText("");
	end
	
	if ( IsCurrentAction(id) or IsAutoRepeatAction(id) ) then
		this:SetChecked(1);
	else
		this:SetChecked(0);
	end
	
	CooldownFrame_SetTimer(cooldown, start, duration, enable);

end

function TrinityChooseButtonStyle()

	if (TrinityButtonStyle == 1) then
	
		TrinityButtonStyle = 2;
		for i=1,10 do
			getglobal("TrinityDockFrame"..i).config["scale"] = getglobal("TrinityDockFrame"..i).config["scale"] + 0.2;
		end
		getglobal("TrinityDockFrame"..TrinityMiscBars["bags"]).config["scale"] = getglobal("TrinityDockFrame"..TrinityMiscBars["bags"]).config["scale"] + 0.2;		
		getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["scale"] = getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["scale"] + 0.2;		
		getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["scale"] = getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["scale"] + 0.2;						
		TrinitySwapTextures(TrinityButtonStyle)
		
	elseif (TrinityButtonStyle == 2) then
	
		TrinityButtonStyle = 1;
		for i=1,10 do
			getglobal("TrinityDockFrame"..i).config["scale"] = getglobal("TrinityDockFrame"..i).config["scale"] - 0.2;
		end
		getglobal("TrinityDockFrame"..TrinityMiscBars["bags"]).config["scale"] = getglobal("TrinityDockFrame"..TrinityMiscBars["bags"]).config["scale"] - 0.2;		
		getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["scale"] = getglobal("TrinityDockFrame"..TrinityMiscBars["pet"]).config["scale"] - 0.2;		
		getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["scale"] = getglobal("TrinityDockFrame"..TrinityMiscBars["form"]).config["scale"] - 0.2;				
		TrinitySwapTextures(TrinityButtonStyle)
	end	
end

function TrinitySwapTextures(num)

	local defaultElement = {} 	

	if (num == 1) then

		for i=1,120 do
		
			actionButton = getglobal("TrinityActionButton"..i);
			
			actionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
			getglobal(actionButton:GetName().."NormalTexture"):SetWidth(60);
			getglobal(actionButton:GetName().."NormalTexture"):SetHeight(60);			
			getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
			getglobal(actionButton:GetName().."Border"):SetWidth(60);
			getglobal(actionButton:GetName().."Border"):SetHeight(60);			
			actionButton:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
			getglobal("TrinityActionButton"..i.."BindFrame"):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
			actionButton:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
			actionButton:SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");			
			getglobal(actionButton:GetName().."Sheen"):SetTexture("");			
			getglobal(actionButton:GetName().."IconFrame"):SetWidth(36);
			getglobal(actionButton:GetName().."IconFrame"):SetHeight(36);			
			getglobal(actionButton:GetName().."HotKey"):SetTextHeight(12);
			getglobal(actionButton:GetName().."HotKey"):SetPoint("TOPLEFT", -1, -5);
			getglobal(actionButton:GetName().."Count"):SetTextHeight(14);
			getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOMRIGHT", -2, 2);									
		end	
		
		defaultElement[1] = CharacterBag2Slot:GetName();	
		defaultElement[2] = CharacterBag3Slot:GetName();
		defaultElement[3] = CharacterBag1Slot:GetName();
		defaultElement[4] = CharacterBag0Slot:GetName();
		defaultElement[5] = MainMenuBarBackpackButton:GetName();	
		defaultElement[6] = TrinityBagDoodads:GetName();
		
		for i=1,6 do
			getglobal(defaultElement[i]):SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
			getglobal(defaultElement[i].."NormalTexture"):SetWidth(60);
			getglobal(defaultElement[i].."NormalTexture"):SetHeight(60);
			getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
			getglobal(defaultElement[i].."NormalTexture"):SetPoint("CENTER",0,0);												
			getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
			getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
			getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");									
			getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");						
			getglobal(defaultElement[i].."Sheen"):SetTexture("");
			if (i~=6) then
				getglobal(defaultElement[i].."IconTexture"):ClearAllPoints();
				getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPLEFT",0,0);		
				getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMLEFT",0,0);		
				getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPRIGHT",0,0);		
				getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMRIGHT",0,0);		
			else
				KeyRingButton:SetScale(1);
				KeyRingButton:SetFrameStrata("LOW");
				KeyRingButton:SetPoint("CENTER", "TrinityBagDoodads", "LEFT", 27, 0); 	 				
				TrinityLatencyBarFrame:SetScale(1);
				TrinityLatencyBarFrame:SetFrameStrata("LOW");
				TrinityLatencyBarFrame:SetPoint("CENTER", "TrinityBagDoodads", "CENTER", -9, 0);	
			end			
		end
		
		for i=1,10 do
			
			local _, _, _, _, _, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
		
			defaultElement[i] = getglobal("PetActionButton"..i):GetName();			
		
			getglobal(defaultElement[i]):SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
			getglobal(defaultElement[i].."NormalTexture2"):SetWidth(60);
			getglobal(defaultElement[i].."NormalTexture2"):SetHeight(60);			
			getglobal(defaultElement[i].."NormalTexture2"):ClearAllPoints();
			getglobal(defaultElement[i].."NormalTexture2"):SetPoint("CENTER",0,0);									
			getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
			getglobal(defaultElement[i].."Border"):SetWidth(60);
			getglobal(defaultElement[i].."Border"):SetHeight(60);			
			getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
			getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
			getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
			getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
			getglobal(defaultElement[i].."Sheen"):SetTexture("");
			getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
			getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
			getglobal(defaultElement[i].."Cooldown"):SetScale(0.83);
			getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("MEDIUM");						
			if ( autoCastAllowed ) then
				getglobal(defaultElement[i].."AutoCastable"):Show();
			else
				getglobal(defaultElement[i].."AutoCastable"):Hide();
			end
			if ( autoCastEnabled ) then
				getglobal(defaultElement[i].."AutoCast"):Show();
			else
				getglobal(defaultElement[i].."AutoCast"):Hide();
			end					
			getglobal(defaultElement[i].."AutoCastable"):SetTexture("Interface\Buttons\UI-AutoCastableOverlay");
			getglobal(defaultElement[i].."Icon"):ClearAllPoints();
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",0,0);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",0,0);		
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",0,0);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
			getglobal(defaultElement[i].."HotKey"):SetTextHeight(12);
			getglobal(defaultElement[i].."HotKey"):SetPoint("TOPLEFT", -1, -5);
			getglobal(defaultElement[i].."Count"):SetTextHeight(14);
			getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -2, 2);				
		end				
		
		for i=1,10 do
		
			defaultElement[i] = getglobal("ShapeshiftButton"..i):GetName();			
		
			getglobal(defaultElement[i]):SetNormalTexture("")
			getglobal(defaultElement[i].."NormalTexture"):SetWidth(60);
			getglobal(defaultElement[i].."NormalTexture"):SetHeight(60);			
			getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
			getglobal(defaultElement[i].."NormalTexture"):SetPoint("CENTER",0,0);									
			getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Buttons\\UI-ActionButton-Border");
			getglobal(defaultElement[i].."Border"):SetWidth(60);
			getglobal(defaultElement[i].."Border"):SetHeight(60);			
			getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
			getglobal("TrinitySpellBinderButton"..i+12):SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square");			
			getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight");			
			getglobal(defaultElement[i]):SetPushedTexture("Interface\\Buttons\\UI-Quickslot-Depress");						
			getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");			
			getglobal(defaultElement[i].."Sheen"):SetTexture("");
			getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
			getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",0, 0);		
			getglobal(defaultElement[i].."Cooldown"):SetScale(0.83);
			getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("MEDIUM");			
			getglobal(defaultElement[i].."Icon"):ClearAllPoints();
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",0,0);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",0,0);		
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",0,0);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",0,0);			
			getglobal(defaultElement[i].."HotKey"):SetTextHeight(12);
			getglobal(defaultElement[i].."HotKey"):SetPoint("TOPRIGHT", 0, -3);
			getglobal(defaultElement[i].."Count"):SetTextHeight(14);
			getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -2, 2);		
		end	
	
	elseif (num == 2) then
	
		if (OmniCC) then
			if (OmniCC.size > 16) then
				OmniCC.size = 16;
			end
		end
	
		for i=1,120 do
		
			actionButton = getglobal("TrinityActionButton"..i);
			
			actionButton:SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
			getglobal(actionButton:GetName().."NormalTexture"):SetWidth(36);
			getglobal(actionButton:GetName().."NormalTexture"):SetHeight(36);			
			getglobal(actionButton:GetName().."Border"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonBorder.tga");
			getglobal(actionButton:GetName().."Border"):SetWidth(36);
			getglobal(actionButton:GetName().."Border"):SetHeight(36);			
			actionButton:SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
			getglobal("TrinityActionButton"..i.."BindFrame"):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
			actionButton:SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
			actionButton:SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");			
			getglobal(actionButton:GetName().."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");			
			getglobal(actionButton:GetName().."IconFrame"):SetWidth(25);
			getglobal(actionButton:GetName().."IconFrame"):SetHeight(25);
			getglobal(actionButton:GetName().."IconFrame".."Cooldown"):SetScale(0.73);
			getglobal(actionButton:GetName().."HotKey"):SetTextHeight(10);
			getglobal(actionButton:GetName().."HotKey"):SetPoint("TOPLEFT", -6, -6);
			getglobal(actionButton:GetName().."Count"):SetTextHeight(10);
			getglobal(actionButton:GetName().."Count"):SetPoint("BOTTOMRIGHT", -6, 5);						
		end						
		
		defaultElement[1] = CharacterBag2Slot:GetName();	
		defaultElement[2] = CharacterBag3Slot:GetName();
		defaultElement[3] = CharacterBag1Slot:GetName();
		defaultElement[4] = CharacterBag0Slot:GetName();
		defaultElement[5] = MainMenuBarBackpackButton:GetName();
		defaultElement[6] = TrinityBagDoodads:GetName();
		
		for i=1,6 do
			getglobal(defaultElement[i]):SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
			getglobal(defaultElement[i].."NormalTexture"):SetWidth(36);
			getglobal(defaultElement[i].."NormalTexture"):SetHeight(36);
			getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
			getglobal(defaultElement[i].."NormalTexture"):SetPoint("TOP",0,-0.5);												
			getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
			getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
			getglobal(defaultElement[i]):SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");						
			getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
			getglobal(defaultElement[i].."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");
			if (i~=6) then
				getglobal(defaultElement[i].."IconTexture"):ClearAllPoints();
				getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPLEFT",7,-7);		
				getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMLEFT",7,6);		
				getglobal(defaultElement[i].."IconTexture"):SetPoint("TOPRIGHT",-7,-7);		
				getglobal(defaultElement[i].."IconTexture"):SetPoint("BOTTOMRIGHT",7,6);
			else
				KeyRingButton:SetScale(0.7);
				KeyRingButton:SetFrameStrata("BACKGROUND");
				KeyRingButton:SetPoint("CENTER", "TrinityBagDoodads", "LEFT", 34, 0); 	 				
				TrinityLatencyBarFrame:SetScale(0.7);
				TrinityLatencyBarFrame:SetFrameStrata("BACKGROUND");
				TrinityLatencyBarFrame:SetPoint("CENTER", "TrinityBagDoodads", "CENTER", -7, 0);	
			end
		end
		
		for i=1,10 do
		
			defaultElement[i] = getglobal("PetActionButton"..i):GetName();			
		
			getglobal(defaultElement[i]):SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
			getglobal(defaultElement[i].."NormalTexture2"):SetWidth(32);
			getglobal(defaultElement[i].."NormalTexture2"):SetHeight(32);			
			getglobal(defaultElement[i].."NormalTexture2"):ClearAllPoints();
			getglobal(defaultElement[i].."NormalTexture2"):SetPoint("TOP",0,1);									
			getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonBorder.tga");
			getglobal(defaultElement[i].."Border"):SetWidth(36);
			getglobal(defaultElement[i].."Border"):SetHeight(36);			
			getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
			getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
			getglobal(defaultElement[i]):SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");			
			getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
			getglobal(defaultElement[i].."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");
			getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
			getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",12, 12);		
			getglobal(defaultElement[i].."Cooldown"):SetScale(0.5);
			getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("LOW");
			getglobal(defaultElement[i].."Cooldown"):SetFrameLevel(1);			
			getglobal(defaultElement[i].."AutoCast"):Hide()
			getglobal(defaultElement[i].."AutoCastable"):SetTexture("");
			getglobal(defaultElement[i].."Icon"):ClearAllPoints();
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",5,-5);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",5, 5);		
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",-5,-5);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",5,5);			
			getglobal(defaultElement[i].."HotKey"):SetTextHeight(10);
			getglobal(defaultElement[i].."HotKey"):SetPoint("TOPLEFT", -6, -6);
			getglobal(defaultElement[i].."Count"):SetTextHeight(10);
			getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				
		end		
		
		for i=1,10 do
		
			defaultElement[i] = getglobal("ShapeshiftButton"..i):GetName();			
		
			getglobal(defaultElement[i]):SetNormalTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButton.tga")
			getglobal(defaultElement[i].."NormalTexture"):SetWidth(32);
			getglobal(defaultElement[i].."NormalTexture"):SetHeight(32);			
			getglobal(defaultElement[i].."NormalTexture"):ClearAllPoints();
			getglobal(defaultElement[i].."NormalTexture"):SetPoint("TOP",0,1);												
			getglobal(defaultElement[i].."Border"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonBorder.tga");
			getglobal(defaultElement[i].."Border"):SetWidth(36);
			getglobal(defaultElement[i].."Border"):SetHeight(36);			
			getglobal(defaultElement[i]):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
			getglobal("TrinitySpellBinderButton"..i+12):SetHighlightTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonHiLight.tga");			
			getglobal(defaultElement[i]):SetCheckedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonChecked.tga");			
			getglobal(defaultElement[i]):SetPushedTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonPushed.tga");			
			getglobal(defaultElement[i]):CreateTexture("$parentSheen", "OVERLAY", "TrinityCheckButtonSheenTemplate");
			getglobal(defaultElement[i].."Sheen"):SetTexture("Interface\\Addons\\TrinityButtons\\Images\\RoundButtonSheen.tga");
			getglobal(defaultElement[i].."Cooldown"):ClearAllPoints();
			getglobal(defaultElement[i].."Cooldown"):SetPoint("BOTTOMLEFT",12, 12);		
			getglobal(defaultElement[i].."Cooldown"):SetScale(0.5);
			getglobal(defaultElement[i].."Cooldown"):SetFrameStrata("LOW");
			getglobal(defaultElement[i].."Cooldown"):SetFrameLevel(1);
			getglobal(defaultElement[i].."Icon"):ClearAllPoints();
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPLEFT",5,-5);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMLEFT",5, 5);		
			getglobal(defaultElement[i].."Icon"):SetPoint("TOPRIGHT",-5,-5);		
			getglobal(defaultElement[i].."Icon"):SetPoint("BOTTOMRIGHT",5,5);			
			getglobal(defaultElement[i].."HotKey"):SetTextHeight(10);
			getglobal(defaultElement[i].."HotKey"):SetPoint("TOPRIGHT", -4, -4);
			getglobal(defaultElement[i].."Count"):SetTextHeight(10);
			getglobal(defaultElement[i].."Count"):SetPoint("BOTTOMRIGHT", -6, 5);				
		end
		
		
	end
	
	TrinityUpdateDocking();
end	

-- A function to determine where the mouse is located for the binding tool.
function TrinitySetBindingOnUpdate(elapsed)

	if (this.elapsedTime) then
		this.elapsedTime = this.elapsedTime + elapsed;
	else
		this.elapsedTime = elapsed;
	end
	
	if (this.reminder) then
		this.reminder = this.reminder + elapsed;
	else
		this.reminder = elapsed;
	end
	
	if (this.elapsedTime < 0.1) then
		return;
	end	
	
	if (this.reminder > 20) then
		UIErrorsFrame:AddMessage("Key Binding is Active.", 1.0, 1.0, 1.0, 1.0, UIERRORS_HOLD_TIME);												
		this.reminder = nil;
	end	
	
	this.elapsedTime = nil;	
	
	if (TrinityKeyBindButton == 0) then
	
		local obj = GetMouseFocus();
		local frame, id;
	
		if (obj and obj:GetName()) then
			frame = obj:GetName();
			id = obj:GetID();		
			if (string.find(frame, "TrinityActionButton")) then
				this:EnableKeyboard(true);				
				GameTooltip:AddLine("\nHit a key to bind it to |cff00ff00Action Button "..id.."|r", 1.0, 1.0, 1.0);
				GameTooltip:AddLine("Hit |cfff00000ESC|r to clear this button's current binding", 1.0, 1.0, 1.0);
				TrinityKeyBindButton = id;				
			end
		end			
	end
	
	if (not TrinityKeyBindSpell) then
	
		local obj = GetMouseFocus();
		local frame, id;
	
		if (obj and obj:GetName()) then
			frame = obj:GetName();
			id = obj:GetID();		
			if (string.find(frame, "TrinitySpellBinderButton")) then
				if (string.find(obj:GetParent():GetName(), "SpellButton")) then
					local spellid = SpellBook_GetSpellID(id);
					local spellName, subSpellName = GetSpellName(spellid, SpellBookFrame.bookType);
					local texture = GetSpellTexture(spellid, SpellBookFrame.bookType);			
					this:EnableKeyboard(true);				
					GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..spellName.."("..subSpellName..")|r", 1.0, 1.0, 1.0);	
					GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this spell's binding", 1.0, 1.0, 1.0);																				
					TrinityKeyBindSpell = spellid..spellName.."("..subSpellName..")";
					
				elseif (string.find(obj:GetParent():GetName(), "ShapeshiftButton")) then
			 		local _, formName, _ = GetShapeshiftFormInfo(obj:GetID()-12); 														
					this:EnableKeyboard(true);				
					GameTooltip:AddLine("\n Hit a key to bind it to |cff00ff00"..formName.."()|r", 1.0, 1.0, 1.0);	
					GameTooltip:AddLine(" Hit |cfff00000ESC|r to clear this form's binding", 1.0, 1.0, 1.0);																				
					TrinityKeyBindSpell = formName.."()";				
				end
			end
		end
	end
	
	GameTooltip:Show();
end

-- The main function to bind keys to buttons.
function TrinitySetBinding(bindkey, modifier, spell)	

	local key;
	local keytext;
	local stance = 0;	
	
	if (modifier) then
		key = modifier..bindkey;
		
		if (string.find(bindkey, "BUTTON")) then
			keytext = string.lower(string.gsub(modifier, "(%a)(%a+)", "%1"))..string.gsub(bindkey,"(%a+)(%d)","m%2");
		else
			keytext = string.lower(string.gsub(modifier, "(%a)(%a+)", "%1"))..bindkey;  
		end
	else
		key = bindkey;
		if (string.find(bindkey, "BUTTON")) then
			keytext = string.gsub(bindkey,"(%a+)(%d)","m%2");
		else
			keytext = bindkey;
		end
	end
	
	if (bindkey == "ESCAPE") then
		key = "";
		keytext = "";						
	end	
	
	for k,v in pairs(TrinitySpellBindings) do
		if (v == key) then
			TrinitySpellBindings[k] = "";			
		end
		if (v == keytext) then
			TrinitySpellBindings[k] = "";
		end
	end				
	
	if (spell) then
		actionButton = TrinityActionButton0;		
		actionButtonHotkey = getglobal(actionButton:GetName().."HotKey");
		if (TrinitySpellBindings[spell]) then
			SetOverrideBindingSpell(TrinityTempDockFrame, false, TrinitySpellBindings[spell], "");		
		end
		TrinitySpellBindings[spell] = key; 
		TrinitySpellBindings[spell.."-HotKey"] = keytext; 				
	else
		actionButton = getglobal("TrinityActionButton"..TrinityKeyBindButton);
		actionButtonHotkey = getglobal(actionButton:GetName().."HotKey");
		if (actionButton.hotkey) then
			SetOverrideBindingClick(TrinityTempDockFrame, false, actionButton.hotkey, "TrinityActionButton0");						
			SetBinding(actionButton.hotkey, nil);
		end				
	end
	
	if (actionButton ~= TrinityActionButton0) then	
		stance = TrinityGetStance(getglobal("TrinityDockFrame"..actionButton.dock));
	end
	
	actionButtonHotkey:SetText(keytext);
	actionButton.hotkey = key;
	actionButton.hotkeytext = keytext;	

	for i=1,120 do
		if (i ~= actionButton:GetID()) then
			if (getglobal("TrinityActionButton"..i).dock == actionButton.dock) then
				if (getglobal("TrinityActionButton"..i):GetAttribute("showstates") == actionButton:GetAttribute("showstates")) then			
					if (getglobal("TrinityActionButton"..i).hotkey == key) then																
						SetBinding(getglobal("TrinityActionButton"..i).hotkey, nil)
						TrinitySetStateBindings(getglobal("TrinityActionButton"..i), nil)
						getglobal("TrinityActionButton"..i).hotkey = "";
						getglobal("TrinityActionButton"..i).hotkeytext = "";
						getglobal("TrinityActionButton"..i.."HotKey"):SetText("");						
					end
				else			
					local buttonList = {};				
					for i=0,9 do
						buttonList[i] = {};
						string.gsub(getglobal("TrinityDockFrame"..actionButton.dock).buttonList[i], "%d+", function (btn) table.insert(buttonList[i], btn) end);
					end				
					for k,v in pairs(buttonList[stance]) do					
						if (v == tostring(actionButton:GetID())) then					
							for i=0,9 do
								if (i~=stance) then							
									local found = nil;
									for key,value in pairs(buttonList[i]) do
										if (getglobal("TrinityActionButton"..v).hotkey == getglobal("TrinityActionButton"..value).hotkey) then
											found = true;										
										end
									end	
									if (not found) then
										if (buttonList[i][k]) then																		
											if (not getglobal("TrinityActionButton"..buttonList[i][k]).hotkey or getglobal("TrinityActionButton"..buttonList[i][k]).hotkey == "") then
												TrinitySetStateBindings(getglobal("TrinityActionButton"..buttonList[i][k]), key)
												getglobal("TrinityActionButton"..buttonList[i][k]).hotkey = key;
												getglobal("TrinityActionButton"..buttonList[i][k]).hotkeytext = keytext;
												getglobal("TrinityActionButton"..buttonList[i][k].."HotKey"):SetText(keytext);						
											end
										end
									end
								end
							end
						end					
					end
				end		
			
			elseif (getglobal("TrinityActionButton"..i).hotkey == key) then						
				SetBinding(getglobal("TrinityActionButton"..i).hotkey, nil)
				TrinitySetStateBindings(getglobal("TrinityActionButton"..i), nil)
				getglobal("TrinityActionButton"..i).hotkey = "";
				getglobal("TrinityActionButton"..i).hotkeytext = "";
				getglobal("TrinityActionButton"..i.."HotKey"):SetText("");
			end				
		end		
	end	
	
	SetBinding(key, nil);	
	
	if (key and not spell) then				
		SetBindingClick(key, actionButton:GetName());				
		SetOverrideBindingClick(TrinityTempDockFrame, false, key, actionButton:GetName());				
	end
	
	if (spell) then	
		SetBindingSpell(key, spell);				
		SetOverrideBindingSpell(TrinityTempDockFrame, false, key, spell);				
	end	
	
	TrinityUpdateBindings();	
	
	TrinitySaveButtonState();
end

-- A function to initialize bindings at login and also to update all bindings after a new binding is made.
function TrinityClearBindingKeys()

	for i=1,120 do	
		local actionButton = getglobal("TrinityActionButton"..i);
		if (actionButton.hotkey and actionButton.hotkey ~= "") then
			SetBinding(actionButton.hotkey, nil);
		end
	end
	
	for key, value in pairs(TrinitySpellBindings) do
		if (not string.find(key, "-HotKey")) then
			SetBinding(key, nil);			
		end
	end	
end


function TrinityUpdateBindings()

	if (not TrinityPlayerEnteredWorld) then	
		TrinityClearBindingKeys()
	end
	
	for i=1,120 do
	
		local actionButton = getglobal("TrinityActionButton"..i);		
		
		if (actionButton.dock ~= 99) then
		
			if (actionButton.dock) then
		
				if (actionButton.hotkey) then					
			
					TrinitySetStateBindings(actionButton, actionButton.hotkey);	
					
					if (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityStanceButtons") then
						if (string.find(actionButton:GetAttribute("showstates"), tostring(GetShapeshiftForm()))) then
							SetBindingClick(actionButton.hotkey, actionButton:GetName());						
						end										
					elseif (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityPagedButtons") then
						if (string.find(actionButton:GetAttribute("showstates"), tostring(GetActionBarPage()))) then
							SetBindingClick(actionButton.hotkey, actionButton:GetName());						
						end										
					elseif (getglobal("TrinityDockFrame"..actionButton.dock).config["header"] == "TrinityNormalButtons") then
						if (string.find(actionButton:GetAttribute("showstates"), "0")) then
							SetBindingClick(actionButton.hotkey, actionButton:GetName());						
						end					
					end
				end
			end
		end
	end
	
	for key, value in pairs(TrinitySpellBindings) do
		if (not string.find(key, "-HotKey")) then
			SetBindingSpell(value, key);
		end
	end
	
 	for i=1,GetNumShapeshiftForms() do 		 		
 		local _, formName, _ = GetShapeshiftFormInfo(i); 		 		
 		getglobal("ShapeshiftButton"..i.."HotKey"):SetText();								
		formName = formName.."()-HotKey";
		for k,v in pairs(TrinitySpellBindings) do
			if (k == formName) then
				getglobal("ShapeshiftButton"..i.."HotKey"):SetText(v);								
			end
		end 		
 	end		
end

-- A function to set which state a button will show based on the button header's state.
function TrinitySetStateBindings(actionButton, key)

	if (string.find(actionButton:GetAttribute("showstates"), "0")) then
		actionButton:SetAttribute("bindings-zero", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "1")) then
		actionButton:SetAttribute("bindings-one", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "2")) then
		actionButton:SetAttribute("bindings-two", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "3")) then
		actionButton:SetAttribute("bindings-three", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "4")) then
		actionButton:SetAttribute("bindings-four", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "5")) then
		actionButton:SetAttribute("bindings-five", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "6")) then
		actionButton:SetAttribute("bindings-six", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "7")) then
		actionButton:SetAttribute("bindings-seven", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "8")) then
		actionButton:SetAttribute("bindings-eight", key);
	end
	if (string.find(actionButton:GetAttribute("showstates"), "9")) then
		actionButton:SetAttribute("bindings-nine", key);
	end
	
	return;
end

-- Function to move the minimap icon
function TrinityButtons_IconDraggingFrame_OnUpdate(arg1)

	local pos;
	local xpos,ypos = GetCursorPosition();
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom();

	xpos = xmin-xpos/Minimap:GetEffectiveScale()+70;
	ypos = ypos/Minimap:GetEffectiveScale()-ymin-70;

	pos = math.deg(math.atan2(ypos,xpos));	
	
	xpos = 80*cos(pos);
	ypos = 80*sin(pos);	

	TrinityButtonsButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-xpos,ypos-55);
	TrinityButtonsButton:SetUserPlaced(true);
	TrinityButtonsButtonLoc = { 50-xpos, ypos-54 };
end



function TrinitySaveButtonState()

	if (TrinityButtonsSavedState["Docks"]) then		
		for i=1,TrinityDockFrames do
			dockFrame = getglobal("TrinityDockFrame"..i);		
			TrinityButtonsSavedState["Docks"][i] = { dockFrame.anchors, dockFrame.lastDocked, dockFrame.buttonCount, dockFrame.buttonList, dockFrame.config, dockFrame:GetCenter() };
		end
	end

	if (TrinityButtonsSavedState["Buttons"]) then			
		for i=1,155 do
			actionButton = getglobal("TrinityActionButton"..i);		
			TrinityButtonsSavedState["Buttons"][i] = { actionButton.dock, actionButton.anchor, actionButton:GetAttribute("showstates"), actionButton.hotkey, actionButton.hotkeytext, actionButton.laststate };		
		end
	end	
	
	if (TrinityButtonsSavedState["TempDock"]) then
		TrinityButtonsSavedState["TempDock"] = { TrinityTempDockFrame.buttonIndex, TrinityTempDockFrame.buttonCount };		
	end
	
	TrinitySavedVersion = TrinityCurrentVersion;
end

-- Function to save the settings of docks and buttons to the variables that will be saved.
function TrinityLoadSV()

	if (not TrinityButtonsSavedState["Docks"]) then		
		TrinityButtonsSavedState["Docks"] = {};
	else
		for i=1,TrinityDockFrames do
		
			local dockFrame = getglobal("TrinityDockFrame"..i);
			
			if (TrinityButtonsSavedState["Docks"][i]) then
			
				if (TrinityButtonsSavedState["Docks"][i][1]) then
					dockFrame.anchors = TrinityButtonsSavedState["Docks"][i][1];
				end
				if (TrinityButtonsSavedState["Docks"][i][2]) then
					dockFrame.lastDocked = TrinityButtonsSavedState["Docks"][i][2];
				end
				if (TrinityButtonsSavedState["Docks"][i][3]) then
					dockFrame.buttonCount = TrinityButtonsSavedState["Docks"][i][3];			
				end
				if (TrinityButtonsSavedState["Docks"][i][4]) then
					dockFrame.buttonList = TrinityButtonsSavedState["Docks"][i][4];			
				end
				if (TrinityButtonsSavedState["Docks"][i][5]) then
					dockFrame.config = TrinityButtonsSavedState["Docks"][i][5];
				end
				if (TrinityButtonsSavedState["Docks"][i][6]) then
					dockFrame.centerx = TrinityButtonsSavedState["Docks"][i][6];			
				end
				if (TrinityButtonsSavedState["Docks"][i][7]) then
					dockFrame.centery = TrinityButtonsSavedState["Docks"][i][7];			
				end
			end
		end
	end
	
	if (not	TrinityButtonsSavedState["Buttons"]) then
		TrinityButtonsSavedState["Buttons"] = {};
	else
		for i=1,155 do			
		
			local actionButton = getglobal("TrinityActionButton"..i);
			
			if (TrinityButtonsSavedState["Buttons"][i]) then			
				if (TrinityButtonsSavedState["Buttons"][i][1]) then
					actionButton.dock = TrinityButtonsSavedState["Buttons"][i][1];
					if (actionButton.dock ~= 99) then
						dockFrame = getglobal("TrinityDockFrame"..actionButton.dock);
						if (type(dockFrame.config) == "table") then
							if (dockFrame.config["header"] == "TrinityStanceButtons" or
							    dockFrame.config["header"] == "TrinityPagedButtons" or
				    			    dockFrame.config["header"] == "TrinityNormalButtons") then
					 			getglobal(dockFrame.config["header"]):SetAttribute("addchild", actionButton);
					 		end
						end
					end
				end
				if (TrinityButtonsSavedState["Buttons"][i][2]) then
					actionButton.anchor = TrinityButtonsSavedState["Buttons"][i][2];
				end
				if (TrinityButtonsSavedState["Buttons"][i][3]) then				
					actionButton:SetAttribute("showstates", TrinityButtonsSavedState["Buttons"][i][3]);
				end
				if (TrinityButtonsSavedState["Buttons"][i][4]) then
					actionButton.hotkey = TrinityButtonsSavedState["Buttons"][i][4];
				end
				if (TrinityButtonsSavedState["Buttons"][i][5]) then
					actionButton.hotkeytext = TrinityButtonsSavedState["Buttons"][i][5];				
				end
				if (TrinityButtonsSavedState["Buttons"][i][6]) then
					actionButton.laststate = TrinityButtonsSavedState["Buttons"][i][6];				
				end			
				
				actionButton:Show();
			end			
		end
	end
	
	if (not	TrinityButtonsSavedState["TempDock"]) then
		TrinityButtonsSavedState["TempDock"] = {};
	else
		if (TrinityButtonsSavedState["TempDock"][1]) then
			TrinityTempDockFrame.buttonIndex = TrinityButtonsSavedState["TempDock"][1];
		end
		if (TrinityButtonsSavedState["TempDock"][2]) then
			TrinityTempDockFrame.buttonCount = TrinityButtonsSavedState["TempDock"][2];			
		end
	end	
	
	if (TrinitySavedVersion ~= TrinityCurrentVersion and not TrinityFirstRun) then
		TrinityUpgradeVersion()
	end
end

-- Blizzard hooked functions

local SavedUpdateTalentButton = UpdateTalentButton;
function TrinityUpdateTalentButton()
	if ( UnitLevel("player") < 10 ) then
		TalentMicroButton:Hide();
	else	
		TalentMicroButton:Show();		
	end
end
UpdateTalentButton = TrinityUpdateTalentButton;

local SavedShapeshiftBar_UpdateState = ShapeshiftBar_UpdateState;
function TrinityShapeshiftBar_UpdateState()
	local numForms = GetNumShapeshiftForms();
	for i=1, NUM_SHAPESHIFT_SLOTS do
		button = getglobal("ShapeshiftButton"..i);
		icon = getglobal("ShapeshiftButton"..i.."Icon");
		if ( i <= numForms ) then
			texture, name, isActive, isCastable = GetShapeshiftFormInfo(i);
			icon:SetTexture(texture);		
		
			cooldown = getglobal("ShapeshiftButton"..i.."Cooldown");
			
			if (TrinityButtonStyle == 1) then
				--Cooldown stuffs				
				if ( texture ) then
					cooldown:Show();
				else
					cooldown:Hide();
				end		
			end

			start, duration, enable = GetShapeshiftFormCooldown(i);
			CooldownFrame_SetTimer(cooldown, start, duration, enable);
			
			if ( isActive ) then
				ShapeshiftBarFrame.lastSelected = button:GetID();
				button:SetChecked(1);
			else
				button:SetChecked(0);
			end

			if ( isCastable ) then
				icon:SetVertexColor(1.0, 1.0, 1.0);
			else
				icon:SetVertexColor(0.4, 0.4, 0.4);
			end
		end
	end
end
ShapeshiftBar_UpdateState = TrinityShapeshiftBar_UpdateState;

SavedPetActionBar_Update = PetActionBar_Update;
function TrinityPetActionBar_Update()
	local petActionButton, petActionIcon;
	local petActionsUsable = GetPetActionsUsable();
	for i=1, NUM_PET_ACTION_SLOTS, 1 do
		petActionButton = getglobal("PetActionButton"..i);
		petActionIcon = getglobal("PetActionButton"..i.."Icon");
		petAutoCastableTexture = getglobal("PetActionButton"..i.."AutoCastable");
		petAutoCastModel = getglobal("PetActionButton"..i.."AutoCast");
		local name, subtext, texture, isToken, isActive, autoCastAllowed, autoCastEnabled = GetPetActionInfo(i);
		if ( not isToken ) then
			petActionIcon:SetTexture(texture);
			petActionButton.tooltipName = name;
		else
			petActionIcon:SetTexture(getglobal(texture));
			petActionButton.tooltipName = TEXT(getglobal(name));
		end
		petActionButton.isToken = isToken;
		petActionButton.tooltipSubtext = subtext;
		if ( isActive ) then
			petActionButton:SetChecked(1);
		else
			petActionButton:SetChecked(0);
		end
		if (TrinityButtonStyle == 1) then
			if ( autoCastAllowed ) then
				petAutoCastableTexture:Show();
			else
				petAutoCastableTexture:Hide();
			end
			if ( autoCastEnabled ) then
				petAutoCastModel:Show();
			else
				petAutoCastModel:Hide();
			end		
		end
		
		if (not InCombatLockdown()) then
			if ( name ) then
				petActionButton:Show();
			else
				if ( PetActionBarFrame.showgrid == 0 ) then
					petActionButton:Hide();
				end
			end
		end
		if ( texture ) then
			if ( petActionsUsable ) then
				SetDesaturation(petActionIcon, nil);
			else
				SetDesaturation(petActionIcon, 1);
			end
			petActionIcon:Show();
			if (TrinityButtonStyle == 1) then
				petActionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
			end
		else
			petActionIcon:Hide();
			if (TrinityButtonStyle == 1) then
				petActionButton:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
			end
		end
	end
	
	PetActionBar_UpdateCooldowns();
	
	if ( not PetHasActionBar() ) then
		--ControlReleased();
		HidePetActionBar();
	end
end
PetActionBar_Update = TrinityPetActionBar_Update;

SavedCastingBarFrame_OnUpdate = CastingBarFrame_OnUpdate;
function TrinityCastingBarFrame_OnUpdate()
	local barSpark = getglobal(this:GetName().."Spark");
	local barFlash = getglobal(this:GetName().."Flash");

	if ( this.casting ) then
		local status = GetTime();
		if ( status > this.maxValue ) then
			status = this.maxValue;
		end
		if ( status == this.maxValue ) then
			this:SetValue(this.maxValue);
			CastingBarFrame_FinishSpell(barSpark, barFlash);
			return;
		end
		this:SetValue(status);
		if ( barFlash ) then
			barFlash:Hide();
		end
		if (getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]).config["shape"] == 1) then			
			local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetParent():GetHeight();
			if ( sparkPosition < 0 ) then
				sparkPosition = 0;
			end		
			if ( barSpark ) then
				barSpark:SetPoint("CENTER", this, "BOTTOM", 0, sparkPosition);
			end			
		
		else
			local sparkPosition = ((status - this.startTime) / (this.maxValue - this.startTime)) * this:GetParent():GetWidth();
			if ( sparkPosition < 0 ) then
				sparkPosition = 0;
			end
			if ( barSpark ) then
				barSpark:SetPoint("CENTER", this, "LEFT", sparkPosition, 2);
			end			
		end

	elseif ( this.channeling ) then
		local time = GetTime();
		if ( time > this.endTime ) then
			time = this.endTime;
		end
		if ( time == this.endTime ) then
			CastingBarFrame_FinishSpell(barSpark, barFlash);
			return;
		end
		local barValue = this.startTime + (this.endTime - time);
		this:SetValue( barValue );
		if ( barFlash ) then
			barFlash:Hide();
		end
	elseif ( GetTime() < this.holdTime ) then
		return;
	elseif ( this.flash ) then
		local alpha = 0;
		if ( barFlash ) then
			alpha = barFlash:GetAlpha() + CASTING_BAR_FLASH_STEP;
		end
		if ( alpha < 1 ) then
			if ( barFlash ) then
				barFlash:SetAlpha(alpha);
			end
		else
			if ( barFlash ) then
				barFlash:SetAlpha(1.0);
			end
			this.flash = nil;
		end
	elseif ( this.fadeOut ) then
		local alpha = this:GetAlpha() - CASTING_BAR_ALPHA_STEP;
		if ( alpha > 0 ) then
			this:SetAlpha(alpha);
		else
			this.fadeOut = nil;
			this:Hide();
		end
	end
end
CastingBarFrame_OnUpdate = TrinityCastingBarFrame_OnUpdate;

SavedMainMenuBar_UpdateKeyRing = MainMenuBar_UpdateKeyRing
function TrinityMainMenuBar_UpdateKeyRing()
	if ( SHOW_KEYRING == 1 ) then
		MainMenuBarTexture3:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-KeyRing");
		MainMenuBarTexture3:SetTexCoord(0, 1, 0.1640625, 0.5);
		MainMenuBarTexture2:SetTexture("Interface\\MainMenuBar\\UI-MainMenuBar-KeyRing");
		MainMenuBarTexture2:SetTexCoord(0, 1, 0.6640625, 1);		
		KeyRingButton:Show();
	end
end
MainMenuBar_UpdateKeyRing = TrinityMainMenuBar_UpdateKeyRing;

function TrinityCastingBarFrame_OnEvent(newevent, newarg1)		
	if (string.find(newevent, "START") and getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]).config["shape"] == 1) then
		if (TrinityCastingBarText:GetText()) then
			local barText = TrinityCastingBarText:GetText();
			barText = string.gsub(barText, "%P", "%1\n");
			TrinityCastingBarText:SetText(barText);			
			return
		end
	end	

	if ( newevent == "UNIT_SPELLCAST_FAILED" or newevent == "UNIT_SPELLCAST_INTERRUPTED" and getglobal("TrinityDockFrame"..TrinityMiscBars["cast"]).config["shape"] == 1) then
		if (TrinityCastingBarText:GetText()) then
			local barText = TrinityCastingBarText:GetText();
			barText = string.gsub(barText, "%a", "%1\n");
			TrinityCastingBarText:SetText(barText);			
			return		
		end
	end
end

function TrinityShapeshiftBar_UpdatePosition()

	if (TrinityButtonStyle == 2) then
		for i=1, GetNumShapeshiftForms() do
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(32);
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(32);
		end

	end
end

function TrinityUIParent_ManageFramePositions()

	if (TrinityButtonStyle == 2) then
		for i=1, GetNumShapeshiftForms() do
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetWidth(32);
			getglobal("ShapeshiftButton"..i.."NormalTexture"):SetHeight(32);
		end

	end
end